unit editpole;
{$I defines.inc}
{$I-,B-,R-}

interface
uses Dos,Objects,Vaznik,TEdRadky,Wokna32,VenomGFX,Lacrt,FNfont2;

const
    edna_OK       = 0;
    edna_NOFILE   = 1;
    edna_CANCELED = 2;
type
Tkurpoz = record
   x,y:longint;      {Y=cislo radky;X=bajt v radku (v unicode nemusi platit 1bajt=1znak)}
   vx:longint;      {verejne X. cislo znaku v radce v NEunicode VX=X}
   r:PVaznik;      {na nem bude PEdRadek tzn. ukazatel na radek s kurzorem}
end;

PEditacniPole = ^EditacniPole;
EditacniPole = object(TWoknaZaklad)
       radky:PVaznik;      {jsou tam navazany typy PEdRadek}
       pozice:TKurpoz;
       posledni_vyskyt:TKurpoz;
       PozText:record
          odz,doz,
          posunv,posunm:longint;
          end;
       PocetRadku:longint;
       konverze_tagu:boolean;
       jednotna_vyska_radku:boolean;
       unicode:boolean;
       povolene_zmeny:boolean;
       {true=kdyz nacita soubor, tak zdvojuje vsechny znaky "<", aby se neinterpretovaly
       jako tagy. Pri ukladani je zase naopak odmazava.
       false=u nacitaneho souboru predpoklada, ze tagy obsahuje, takze zadne konverze nedela
       Default je TRUE}
       kx,ky,kd:longint;      {X a Y poloha kurzoru a jeho vyska}
       kkx,kky:longint;
       kpoz:virtualwindow;
       odz,doz:longint;       {na radku s kurzorem jsou vypsany znaky od ODZ do DOZ}
       virt:PVirtualWindow;
       pozadi,popredi:word;   {default: 65535,0}
       poc_zobrX,poc_zobrY:longint;    {posun virtualni obrazovky (pro rizeni scrollingu)}

       po_kl_pozice:TKurpoz;       {sem si ulozim pozici kurzoru pred odjetim posuvnikem}
       po_kl_poc_zobrX,po_kl_poc_zobrY:longint; {uschova scrolovatek}
       po_kl_jsme_mimo:boolean;
       po_kl_rozpr:boolean;{posuvniko-klavesovy rozpor}

       prv_rad,posl_rad:PVaznik;       {Prvni a posledni vypsany radek}
       po_kl_prv_rad,po_kl_posl_rad:PVaznik; {a jejich uschova}
       tot_posl:PVaznik;               {Uplne posledni radka souboru}
       py:posuvnik;
       puvodni_citac:dword;
       je_videt:boolean;      {je zrovna videt kurzor?}
       rychlost_blikani:byte;
       zalamuj:boolean;       {ma zalamovat radky?}
       tab_na_mezery:byte;
       byla_zmena:boolean;
       ED_key_proc:Function(o:word):word;
       ED_zobr_proc:Procedure;
       ED_PMys_proc:Procedure(e:PEditacniPole);
       ukaz_postup_nahravani:Function(r:real):boolean;
       mimoradne_osetreni_klavesnice:Function(o:word):string;
       prac1,prac2:longint;
       sx,svx,sy:longint;     {zaloha polohy kurzoru}
       sr:PVaznik;            {nekdy se to muze hodit}
       Constructor Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
       Procedure Zobraz;virtual;
       procedure Kontrola;virtual;
       Function NactiSoubor(s:string):byte;
       {edna_OK = vse v poradku, edna_NOFILE = neexistujici soubor,
        edna_CANCELED = zrusene nacitani}
       Function UlozSoubor(s:string):boolean;
       Function NactiZeStreamu(var s:TStream):byte;
       Function UlozDoStreamu(var s:TStream):boolean;
       Function NactiZVazniku(p:PVaznik):boolean;
       {Na vaznik jsou pripojeny PStringy}
       Procedure EP_UberVetsi(v:PEdRadek);
       Procedure EP_PridejVetsi(v:PEdRadek);
       Procedure EP_ZavriSoubor;
       Procedure ZkusZrusitRozpr;
       Procedure Prilep_K_predeslemu(pr:PVaznik;smezerou:boolean);
       Procedure NalamejBuffer(pr:PVaznik);
       Function MoznyPreskokNahoru:boolean;
       Procedure PridejTextNaPoziciKurzoru(kp:PChar;ksd:longint);
       Procedure PospojujRadky(merit:boolean);
       Procedure PridelRadky;
       Procedure PreskladejRadky;
       Procedure VycentrujNaKurzor;
       Procedure horz_VycentrovaniKurzoru;
       Procedure vert_VycentrovaniKurzoru;
       Procedure ZmenFont(s:string);
       Function DejLinearniPozici:longint;
       Procedure NastavLinearniPozici(i:longint);
       Procedure PosouvaciRezim;
       Procedure ZalamovaciRezim;
       Procedure ZmenBarvuPozadi(w:word);
       Procedure BlikejKurzorem;
       Procedure ZhasniKurzor;
       Procedure RozsvitKurzor;
       Procedure DalsiRadka(u:PChar;poz:longint;ukoncena:boolean);
       Function PismenoZpet:longint;
       Procedure SmazRadku;
       Procedure SmazZacatekRadky;
       Procedure SmazKonecRadky;
       Procedure SmazSlovo;
       Procedure SkocNaZacatek;
       Procedure NovySoubor;
       procedure OsetriVstup;
       Function KrokVpred:longint;
       Function KrokZpet:longint;
       Procedure SipkaDolu;
       Procedure SipkaNahoru;
       Procedure BackSpace;
       Procedure KlavesaDel;
       Procedure KlavesaEnter;
       Procedure KlavesaPGDN;
       Procedure KlavesaPGUP;
       Procedure KlavesaCtrlPGUP;
       Procedure KlavesaCtrlPGDN;
       Procedure KlavesaEnd;
       Procedure KlavesaHome;

       Function ZkontrolujYY:boolean;

       Destructor Done;virtual;
       end;

Procedure TextoveOkno(x,y,sirka,vyska:longint;popis:string;p:PVaznik);

implementation
var font:fn;

Procedure Dummy;begin end;

Function Default_ed_key_proc(o:word):word;
begin
Default_ed_key_proc:=o;
end;

Constructor EditacniPole.Init(ix,iy,_sirka,_vyska:longint;iakt:boolean);
var hv:boolean;
     r:PEdRadek;
     a:longint;
    _virt:Virtualwindow;
begin
inherited init;
automys:=false;
x:=ix; y:=iy;
radky:=New(PVaznik,Init(nil,nil));
r:=New(PEdRadek,Init);
radky^.InitNext(r);
r^.y1:=0;
r^.y2:=Vyska_FN_default-1;
r^.yy:=1;
if iakt then
   begin
   stav:=_aktivni;
   xm:=-mouse.last_px;
   ym:=-mouse.last_py;
   end
   else begin
   stav:=_neaktivni;
   xm:=1;
   ym:=1;
   end;
pozice.x:=1;             {kurzor bude na 1.bajtu radku}
pozice.vx:=1;            {tzn. na prvnim znaku}
pozice.y:=1;             {a na 1.radku}
pozice.r:=radky^.dalsi;  {ukazatel na udaje radku}
tot_posl:=pozice.r;      {uplne posledni radka je zaroven prvni radkou}
posledni_vyskyt.r:=nil;
PocetRadku:=1;
odz:=0;
doz:=0;          {na aktualnim radku se nam prave zobrazuje nulty az nulty znak :-)}
poc_zobrX:=4;    {od ktere X-ove souradnice okna ma zacit vykreslovat radky}
poc_zobrY:=0;    {...a od ktere Y-ove}

vyska:=_vyska;
sirka:=_sirka-_SirPos;   {od celkove sirky odectu velikost posuvniku}
hv:=hned_vykresluj;
hned_vykresluj:=false;
py.Init(ix+sirka,iy,vyska,vyska,0,10,poVERT);
hned_vykresluj:=hv;
po_kl_rozpr:=false;      {posuvniko-klavesovy rozpor}
konverze_tagu:=true;     {pri nacitani zdvojuj znaky "<"}
povolene_zmeny:=true;    {text smi byt menen}
jednotna_vyska_radku:=true; {neni treba zkoumat text radku, vime predem, jak bude vysoky}
unicode:=false;          {nepouzivame rezim unicode}
zalamuj:=false;          {defaultne zalamovat radky nebudu}
mimoradne_osetreni_klavesnice:=nil;
ED_key_proc:=@Default_ed_key_proc;
ED_zobr_proc:=@Dummy;
ED_pmys_proc:=nil;
ukaz_postup_nahravani:=nil;
Init_VW(_virt,sirka,vyska,false);
virt:=@_virt;
hlavni_font:=FN_syst_font;
ofn:=FN_default;
kx:=4;           {pocatecni poloha a delka kurzoru}
kkx:=-1;
ky:=0;
kd:=Vyska_FN_default;
kpoz.hoehe:=kd;
Init_VW(kpoz,1,100,false);
popredi:=txtbarva;
pozadi:=txtpolevbarva;
Clr(virt^,pozadi);
puvodni_citac:=0;
je_videt:=false;      {je zrovna videt kurzor?}
rychlost_blikani:=10;
tab_na_mezery:=5;
byla_zmena:=false;
if hned_vykresluj then zobraz;
end;

procedure editacnipole.kontrola;
   Procedure KlepnutiMysi;
   var op,p:pvaznik;
       v:PEdRadek;
       mx,my:longint;
       b:boolean;

     Procedure OtestujPraveMysitko;
     begin
     if B and (ED_pmys_proc<>nil) then
        begin
        ED_PMys_proc(@self);
        pozice.x:=sx;
        pozice.y:=sy;
        pozice.vx:=svx;
        pozice.r:=sr;
        end;
     end;

   begin
   if povolene_zmeny=false then Exit;
   if Mouse_L then
      if (not Uvnitr(Mouse.last_px,Mouse.last_py,x,y,x+sirka,y+vyska)) then Exit
      else else
   if Mouse_R then
      if (not Uvnitr(Mouse.x,Mouse.y,x,y,x+sirka,y+vyska)) then Exit
      else else Exit;
   {dodatecna kontrola. kdyby nebyla, mohlo by pri manipulaci zvnejsku s
    promennymi STAV a XM a YM dochazet v teto procedure k neplecham}
   mx:=mouse.x-x;
   my:=mouse.y-y+poc_zobrY;
   b:=mouse.b>1;
   mouserel;
   sx:=pozice.X;             {zalohuju si stavajici}
   svx:=pozice.vx;
   sy:=pozice.Y;             {polohu kurzoru}
   sr:=pozice.R;
   {Kliknutim mysi do textu se rovnez odstrani posuvniko-klavesnicovy rozpor}
   if (b=false) then po_kl_rozpr:=false;
   v:=pozice.r^.vazba;
   if my>=v^.y1 then
      if my<=v^.y2 then     {klepli jsme do prave aktivniho radku?}
         begin
         pozice.x:=Pozice_v_retezci(mx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
         pozice.vx:=FN_skut_znak;
         OtestujPraveMysitko;
         end
         else begin
         {klepli jsme na spodnejsi radku, nez je kurzor}
         p:=pozice.r^.dalsi;
         op:=pozice.r;
         while p<>nil do
            begin
            v:=p^.vazba;
            inc(pozice.y);
            if my<=v^.y2 then
               begin
               pozice.x:=Pozice_v_retezci(mx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
               pozice.vx:=FN_skut_znak;
               {if pozice.x<v^.spp then inc(pozice.x);}
               pozice.r:=p;
               OtestujPraveMysitko;
               Exit;
               end;
            op:=p;
            p:=p^.dalsi;
            end;
         {projeli jsme i posledni radku, ale kurzor je jeste nize}
         pozice.x:=Pozice_v_retezci(mx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
         pozice.vx:=FN_skut_znak;
         {if pozice.x<v^.spp then inc(pozice.x);}
         pozice.r:=op;
         end
         else begin
         {klepli jsme na vrchnejsi radku, nez je kurzor}
         p:=pozice.r^.predchozi;
         while p<>nil do
            begin
            v:=p^.vazba;
            dec(pozice.y);
            if my>=v^.y1 then
               begin
               pozice.x:=Pozice_v_retezci(mx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
               pozice.vx:=FN_skut_znak;
               {if pozice.x<v^.spp then inc(pozice.x);}
               pozice.r:=p;
               OtestujPraveMysitko;
               Exit;
               end;
            op:=p;
            p:=p^.predchozi;
            end;
         end;
   end;

   Procedure ZkontrolujPosuvnik;
   begin
   if (mouse.b=1) or (mouse._wdif<>0) or (py.tahaci_stav) then
      if py.kontrola or (mouse._wdif<>0) then
         begin
         if po_kl_rozpr=false then
            begin
            po_kl_pozice:=pozice;  {zapamatuju si momentalni polohu kurzoru}
            po_kl_poc_zobrx:=Poc_ZobrX;
            po_kl_poc_zobry:=Poc_ZobrY;
            po_kl_prv_rad:=prv_rad;
            po_kl_posl_rad:=posl_rad;
            if je_videt then BlikejKurzorem;
            po_kl_rozpr:=true;
            (*PutClippedSprite(cil^,kpoz,kkx,kky);  {chvilkove vypnuti kurzoru}*)
            end;

         poc_zobrY:=py.hodnota;
         end else else py.probehni:=false;
   end;

var i:longint;
    d:dword;
    zmena_bliknuti:boolean;
Begin
{napred rizeni blikani kurzoru}
inherited kontrola;
zmena_bliknuti:=false;
d:=FromTimer;
if d>puvodni_citac+rychlost_blikani then
   begin
   je_videt:=not(je_videt);
   puvodni_citac:=d;
   zmena_bliknuti:=true;
   end;

ZkontrolujPosuvnik;

if not ((stav=_aktivni)or(stav=_escapem)) then
  if Uvnitr(Mouse.last_px,Mouse.last_py,x,y,x+sirka,y+vyska) then
     begin {aktivace v pripade kliknuti mysi do pole}
     stav:=_aktivni;
     zobraz;
     mouserel;
     xm:=-mouse.last_px;
     ym:=-mouse.last_py;
     end else
  else
  begin
  if Uvnitr(Mouse.last_px,Mouse.last_py,x,y,x+sirka,y+vyska) or
     (mouse.last_px=-xm) and (mouse.last_py=-ym) then
     begin
     {Jsme aktivni a mys je v poli. Posuvnik je mimo - pozor}
     if zmena_bliknuti then BlikejKurzorem;
     if (mouse.b<>0) and (py.tahaci_stav=false) then
        begin
        stav:=_aktivni;
        ofn:=FN_default;
        nastavFont(hlavni_font);
        PutClippedSprite(cil^,kpoz,kkx,kky);  {chvilkove vypnuti kurzoru}
        KlepnutiMysi;
        je_videt:=true;puvodni_citac:=FromTimer;BlikejKurzorem;
        nastavFont(ofn);
        xm:=-mouse.last_px;
        ym:=-mouse.last_py;
        zobraz;
        {Vypustil jsem MouseRel a presunul do KlepnutiMysi}
        end;
     end {ne uvnitr}
     else begin
     if stav in [_aktivni,_escapem] then
        begin
        stav:=_odkliknutim;
        zobraz;
        end;
     xm:=mouse.last_px;
     ym:=mouse.last_py;
     Exit;
     end;   {else begin :: uvnitr}
     {Jsme budto na posuvniku nebo nekde uplne jinde}
     if (mouse._wdif<>0) and (po_kl_rozpr) then
        begin
        i:={mouse.w-puv_kolecko}mouse._wdif;
        inc(poc_zobrY,i*30);
        if poc_zobrY<0 then poc_zobrY:=0;
        if poc_zobrY>py.virtvyska-py.vyska then poc_zobrY:=py.virtvyska-py.vyska;
        py.hodnota:=poc_zobrY;
        mouse._wdif:=0;        {ne zcela ciste, ale prijatelne}
        zobraz;
        Exit;
        end;
OsetriVstup;
end;   {else begin :: not ((stav=_akt...}
{OsetriVstup;}
end;


{Mozna by bylo lepsi presunout nasledujici dve funkce do FNFONT2.PAS...}
Function editacniPole.KrokZpet:longint;
var v:PEdRadek;
    j:longint;
begin
v:=pozice.r^.vazba;
if pozice.x<=1 then Exit(0);
dec(pozice.x,FNznakZpet(v^.p,pozice.x-1,unicode,j));
dec(pozice.vx);
if PozText.odz<>0 then         {presahuje tento radek levy okraj obrazovky?}
   if pozice.x<=PozText.odz then
      {inc(poc_zobrX,PozText.posunm);}
      inc(poc_ZobrX,-PozText.posunm);
KrokZpet:=j;
end;

Function editacniPole.KrokVpred:longint;
var v:PEdRadek;
    j,n:longint;
begin
v:=pozice.r^.vazba;
if pozice.x>=v^.spp then Exit(0);
n:=FNznakVpred(v^.p,pozice.x-1,unicode,j);
inc(pozice.x,n);
inc(pozice.vx);
if PozText.doz<>0 then         {presahuje tento radek pravy okraj obrazovky?}
   if pozice.x-1>=PozText.doz then dec(poc_zobrX,PozText.posunv);
KrokVpred:=j;
end;

Procedure editacniPole.SipkaDolu;
var  v:PEdRadek;
     a1,a2:longint;
begin
if po_kl_rozpr and po_kl_jsme_mimo then
   begin
   v:=po_kl_prv_rad^.vazba;
   pozice.r:=po_kl_prv_rad;
   pozice.y:=v^.yy;
   poc_zobrY:=po_kl_poc_zobrY;
   poc_zobrX:=po_kl_poc_zobrX;
   end;
if povolene_zmeny then
   begin
   if pozice.y>=PocetRadku then Exit;
   inc(pozice.y);
   pozice.r:=pozice.r^.dalsi;
   v:=pozice.r^.vazba;
   pozice.x:=Pozice_v_retezci(kx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,v^.spp-1,font);

   pozice.vx:=FN_skut_znak;
   {if pozice.x<v^.spp then inc(pozice.x);}
   {Bude potreba zascrolovat?}
   if FN_poz_v_ret_delka_radky<-poc_zobrX then  {horizontalni scrolling}
      begin
      poc_zobrX:=-FN_poz_v_ret_delka_radky+virt^.breite div 4;
      if poc_zobrX>4 then poc_zobrX:=4;
      end;
   if v^.y2>poc_ZobrY+virt^.hoeheminus1 then     {vertikalni scrolling}
      poc_ZobrY:=v^.y2-virt^.hoeheminus1+1;   {pozor HOEHEMINUS1 neni totez co HOEHE}
   end
   else begin
   v:=tot_posl^.vazba;
   inc(poc_ZobrY,py.tlacitkovy_skok);
   if poc_ZobrY>v^.y2-virt^.hoeheminus1 then
      poc_ZobrY:=v^.y2-virt^.hoeheminus1;
   end;
end;

Procedure editacniPole.SipkaNahoru;
var  v:PEdRadek;
begin
if po_kl_rozpr and po_kl_jsme_mimo then
   begin
   v:=po_kl_posl_rad^.vazba;
   pozice.r:=po_kl_posl_rad;
   pozice.y:=v^.yy;
   poc_zobrY:=po_kl_poc_zobrY;
   poc_zobrX:=po_kl_poc_zobrX;
   end;
if povolene_zmeny then
   begin
   if pozice.y<=1 then Exit;
   dec(pozice.y);
   pozice.r:=pozice.r^.predchozi;
   v:=pozice.r^.vazba;
   pozice.x:=Pozice_v_retezci(kx,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
   pozice.vx:=FN_skut_znak;
   {if pozice.x<v^.spp then inc(pozice.x);}
   {Bude potreba zascrolovat?}
   if FN_poz_v_ret_delka_radky<-poc_zobrX then  {horizontalni scrolling}
      begin
      poc_zobrX:=-FN_poz_v_ret_delka_radky+virt^.breite div 4;
      if poc_zobrX>4 then poc_zobrX:=4;
      end;
   if v^.y1<poc_ZobrY then                      {vertikalni scrolling}
      poc_ZobrY:=v^.y1;
   end
   else begin
   dec(poc_ZobrY,py.tlacitkovy_skok);
   if poc_ZobrY<0 then
      poc_ZobrY:=0;
   end;

end;

Procedure editacniPole.Prilep_K_predeslemu(pr:PVaznik;smezerou:boolean);
var p:PVaznik;
    v,v2:PEdRadek;

begin
p:=pr^.predchozi;
if pr=tot_posl then {jestli rusim posledni radek, tak musim TOT_POSL preznacit}
   tot_posl:=p;
v2:=p^.vazba;
v:=pr^.vazba;
if smezerou then v2^.Vloz(' ',1,v2^.spp);

if pozice.r=pr then          {kurzor je na prilepovanem radku?}
   begin
   pozice.r:=p;                 {presunu ho na predchozi radek}
   dec(pozice.y);
   pozice.x:=v2^.spp-1+pozice.x; {a prepocitam X-ovou souradnici}
   end;

if posledni_vyskyt.r=pr then
   posledni_vyskyt.r:=nil;   {meni se tu rozlozeni radek. Tezko by se to}
                             {hlidalo poradne, tak aspon zrusim zaznam o posl.}
                             {vyskytu}

v2^.Vloz(v^.p,v^.spp-1,v2^.spp);
inc(v2^.gd,v^.gd);
v2^.crlf:=v^.crlf;
Dispose(v,Done);
Dispose(pr,Done);
dec(PocetRadku);    {pocet radku se snizil o jednu}
end;

Function DelkaPrvnihoSlova(p:Pvaznik;var poz:longint):longint;
var i,j:longint;
    q:pchar;
    v2:PEDradek;
begin
v2:=p^.vazba;
q:=v2^.p;
i:=PrvniVyskytZnaku(v2^.p,' ',1);
poz:=i;
if i=0 then Exit(0);
j:=sirka_FN_na_Xpoz(v2^.p,font,i);
DelkaPrvnihoSlova:=j;
end;

Procedure editacniPole.BackSpace;
var l,a,b:longint;
    v,v2:PEdRadek;
    p:PVaznik;
    n:Pchar;
    s:string;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
if pozice.x=1 then if pozice.y=1 then Exit else
   begin
   p:=pozice.r^.predchozi;
   v2:=p^.vazba;
   a:=Sirka_FN(v2^.p,font,v2^.spp-1);
   pozice.vx:=FN_skut_znak;  {FN_skut_znak muze byt nastaven funkcemi Sirka_FN a Pozice_v_retezci}
   Prilep_K_predeslemu(p^.dalsi,false); {soucasne upravi kurzor}

   if (zalamuj=false) then
      begin
      if a>virt^.breiteminus1 then
         poc_zobrX:=-(a-virt^.breiteminus1)-virt^.breite div 4;
      a:=v^.y2-v^.y1+1;
      PosunVaznikuPEdRadek(p^.dalsi,-a);
      {Bude potreba zascrolovat?}
      if v2^.y1<poc_ZobrY then {jo}
         poc_ZobrY:=v2^.y1;
      end
      else begin
      while v2^.crlf<>true do Prilep_k_predeslemu(p^.dalsi,true);
      v2^.gd:=virt^.breite;
      NalamejBuffer(p);
      end;
   Exit;
   end;

l:=pozice.x;

a:=KrokZpet;  {A=0: zadny tag v ceste, A=n: n znaku zabira tag}

b:=l-pozice.x-a;                {o kolik bajtu budeme zkracovat radku?}
s:=v^.VratString(pozice.x,b); {co odmazu?}
b:=Sirka_FN(s,font);          {a jakou to ma grafickou delku?}
v^.Vyjmi(pozice.x,l-pozice.x-a);

dec(v^.gd,b);
if zalamuj {and (v^.crlf=false) and (pozice.r<>tot_posl)} then
   begin
   {napred ke stavajicimu radku pripojim radky nasledujici}
   while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true);

   {a navic jeste musim zkusit pripojit tento radek k predchazejicimu}
   p:=pozice.r^.predchozi;
   if p^.predchozi=nil then p:=p^.dalsi;
   v:=p^.vazba;
   while v^.crlf=false do Prilep_k_predeslemu(p^.dalsi,true);
   v^.gd:=virt^.breite;
   {a ted to vsechno nalamu}
   if Je_Capslock then
      begin
      end;
   NalamejBuffer(p);
   end;
end;

Procedure editacniPole.KlavesaDel;
var l,a,b:longint;
    v,v2:PEdRadek;
    p:Pvaznik;
    s:string;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
if (pozice.x<v^.spp) then
   begin
   l:=pozice.x;
   a:=poc_zobrX;
   KrokVpred;
   b:=pozice.x-l;
   s:=v^.VratString(l,b); {co odmazu?}
   b:=Sirka_FN(s,font);          {a jakou to ma grafickou delku?}
   v^.Vyjmi(l,pozice.x-l);
   dec(v^.gd,b);
   poc_zobrX:=a;
   pozice.x:=l;
   if (zalamuj=true) and (v^.crlf=false) and (pozice.r<>tot_posl) then
      begin
      a:=DelkaPrvnihoSlova(pozice.r^.dalsi,b);
      b:=virt^.breiteminus1-4-v^.gd;
      if b>a then
         begin
         while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true);
         v^.gd:=virt^.breite;
         NalamejBuffer(pozice.r);
         end;
      end;
   end else

if pozice.r=tot_posl then Exit else
   begin
   p:=pozice.r^.dalsi;
   if p=tot_posl then     {jestlize zrusim posledni radek, tak musim preznacit}
      tot_posl:=pozice.r; {TOT_POSL}
   v2:=p^.vazba;
   a:=v^.y2-v^.y1+1;
   Prilep_K_predeslemu(p,false); {Pozor, muze hybat s promennou POZICE}
   if zalamuj then
      begin
      while v^.crlf=false do Prilep_K_predeslemu(pozice.r^.dalsi,true);
      v^.gd:=virt^.breite;
      NalamejBuffer(pozice.r);
      end else PosunVaznikuPEdRadek(pozice.r^.dalsi,-a);
   Exit;
   end;

end;

Procedure editacniPole.KlavesaEnter;
var v,v2:PEdRadek;
    p,q:PVaznik;
    n:PChar;
    a:longint;
begin
if not povolene_zmeny then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
v2:=New(PEdRadek,Init);
p:=New(PVaznik,Init(nil,nil));
p^.vazba:=v2;
pozice.r^.Insert(p);
if pozice.r=tot_posl then {jesltli jsme na uplne poslednim radku souboru}
   tot_posl:=p;           {a vytvorim novy, tak musim aktualizovat TOT_POSL}

v^.Rozdel(v2^,pozice.x,0);
v^.crlf:=true;
a:=v^.y2-v^.y1+1;      {BETA - zatim predpokladam, ze nikde neni zmena vysky fontu}
v2^.y1:=v^.y1;
v2^.y2:=v^.y2;
v2^.yy:=v^.yy;
v2^.crlf:=v^.crlf;

pozice.x:=1;           {po zmacknuti Enteru budeme urcite na prvnim sloupci}
pozice.vx:=1;
inc(pozice.y);
Poc_ZobrX:=4;
inc(PocetRadku);       {prozatim predpokladejme, ze se pocet radku zvysil}
                       {to se po pruchodu zalamovaci procedurou muze zmenit}

v^.crlf:=true;
if (zalamuj=false) {or (v^.crlf=true)} then PosunVaznikuPEdRadek(p,a)
   else begin
   if pozice.y>2 then
      begin
      pozice.r:=p;
      q:=p^.predchozi^.predchozi;
      v:=q^.vazba;
      v^.gd:=virt^.breite;
      if v^.crlf=false then Prilep_k_predeslemu(p^.predchozi,true);
      end else q:=pozice.r;
   while v2^.crlf=false do Prilep_K_predeslemu(p^.dalsi,true);
   v2^.gd:=virt^.breite;
   NalamejBuffer(q);
   end;

pozice.r:=p;           {neboli pozice.r:=pozice.r^.dalsi}
{v^.crlf:=true;}

{Bude potreba zascrolovat?}
if v2^.y2>poc_ZobrY+virt^.hoeheminus1 then {jo}
   poc_ZobrY:=v2^.y2-virt^.hoeheminus1+1;
end;

Procedure editacniPole.KlavesaPGDN;
var v:PEdRadek;
    p,op:PVaznik;
    l:longint;
    b:boolean;
begin
if po_kl_rozpr and po_kl_jsme_mimo then begin SipkaNahoru;Exit;end;
b:=false;
if posl_rad^.dalsi=nil then b:=true else
   begin
   v:=posl_rad^.dalsi^.vazba;
   if v^.y2-poc_ZobrY<virt^.hoehe then b:=true;
   posl_rad:=posl_rad^.dalsi;
   end;
if B then
   begin
   v:=posl_rad^.vazba;
   inc(pozice.y,v^.yy-pozice.y{+1}{posl_od_poz+1});
   pozice.r:=posl_rad;
   pozice.x:=Pozice_v_retezci(kx+poc_ZobrX,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
   pozice.vx:=FN_skut_znak;
   Exit;
   end;
posl_rad:=posl_rad^.predchozi;   {mirne pofiderni...}
v:=posl_rad^.vazba;
l:=ky-poc_zobrY+v^.y1;
poc_zobrY:=v^.y1;

{Mame posunuto. Ted je potreba zjistit, kde se vlastne nachazi kurzor}
p:=posl_rad;
while p<>nil do        {udelam scan od shora dolu...}
   begin
   v:=p^.vazba;
   if v^.y2>l then    {kurzor je na tehle radce}
      begin
      pozice.x:=Pozice_v_retezci(kx+poc_ZobrX,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
      pozice.vx:=FN_skut_znak;
      {if pozice.x<v^.spp then inc(pozice.x);}
      pozice.y:=v^.yy;
      pozice.r:=p;
      Exit;
      end;
   op:=p;
   p:=p^.dalsi;
   end;
{sem bychom se nikdy nemeli dostat, nicmene sem neco napisu...}
pozice.x:=1;
pozice.vx:=1;
pozice.r:=op;
pozice.y:=v^.yy;
end;

Procedure editacniPole.KlavesaPGUP;
var l,m:longint;
    v:PEdRadek;
    p,op:Pvaznik;
begin
if po_kl_rozpr and po_kl_jsme_mimo then begin SipkaDolu;Exit;end;

if prv_rad^.predchozi^.predchozi=nil then
   begin
   pozice.y:=1;
   pozice.r:=radky^.dalsi;
   poc_ZobrY:=0;
   Exit;
   end;

v:=prv_rad^.vazba;
l:=ky-poc_zobrY;
dec(poc_zobrY,virt^.hoehe-(v^.y2-v^.y1+1));
p:=prv_rad;                    {jemne doladeni}
while p^.predchozi<>nil do
   begin
   v:=p^.vazba;
   if v^.y1-poc_zobrY=0 then Break;
   if v^.y1-poc_zobrY<0 then
      begin
      poc_zobrY:=v^.y2+1;      {neprilis ciste :-(}
      Break;
      end;
   p:=p^.predchozi;
   end;
if poc_zobrY<0 then poc_zobrY:=0;

{Mame posunuto. Ted je potreba zjistit, kde se vlastne nachazi kurzor}
l:=l+poc_ZobrY;

if povolene_zmeny then
   begin
   p:=prv_rad;
   while p<>nil do             {provedu scan zdola nahoru}
      begin
      v:=p^.vazba;
      if v^.y1<=l then
         begin
         pozice.x:=Pozice_v_retezci(kx+poc_ZobrX,{v^.y1}-1,poc_zobrX,poc_zobrY,v^.p,font);
         pozice.vx:=FN_skut_znak;
         {if pozice.x<v^.spp then inc(pozice.x);}
         pozice.y:=v^.yy;
         pozice.r:=p;
         Exit;
         end;
      p:=p^.predchozi;
      end;
   end;

{Nasledujici kod by se mel vykonat jenom v pasivnim modu}
pozice.x:=1;
pozice.vx:=1;
pozice.y:=1;
pozice.r:=radky^.dalsi;
end;

Procedure editacniPole.KlavesaCtrlPGUP;
begin
SkocNaZacatek;
end;

Procedure editacniPole.KlavesaCtrlPGDN;
var v:PEdRadek;
begin
pozice.x:=1;
pozice.vx:=1;
pozice.r:=tot_posl;
v:=tot_posl^.vazba;
pozice.y:=v^.yy;
VycentrujNaKurzor;
end;

Procedure editacniPole.KlavesaEND;
var v:PEdRadek;
    a:longint;
begin
v:=pozice.r^.vazba;
a:=Sirka_FN(v^.p,font,v^.spp-1);
pozice.x:=v^.spp;
pozice.vx:=FN_skut_znak;
if a>virt^.breiteminus1 then
   Poc_ZobrX:=-(a-virt^.breiteminus1+4);
end;

Procedure editacniPole.KlavesaHome;
var p:PEdRadek;
begin
pozice.x:=1;
pozice.vx:=1;
Poc_ZobrX:=4;
end;

Function EditacniPole.MoznyPreskokNahoru:boolean;
var v:PEdradek;
    p:Pvaznik;
    i,j:longint;
begin
MoznyPreskokNahoru:=false;
if pozice.y<=1 then Exit;
p:=pozice.r^.predchozi;
v:=p^.vazba;
if v^.crlf then Exit;

i:=DelkaPrvnihoSlova(pozice.r,j);
if j<>pozice.x-1 then Exit;
j:=virt^.breiteminus1-v^.gd-4;
if i<j then
   begin
   Prilep_k_predeslemu(p^.dalsi,true);
   v^.gd:=virt^.breite;
   MoznyPreskokNahoru:=true;
   end;
end;

Procedure editacniPole.PridejTextNaPoziciKurzoru(kp:PChar;ksd:longint);
var v:PEdRadek;
    i:longint;
    b:boolean;
begin
if povolene_zmeny=false then Exit;
if kp[0]=#0 then Exit;
byla_zmena:=true;
v:=pozice.r^.vazba;
v^.Vloz(kp,pozice.x);
inc(pozice.x,ksd);
inc(pozice.vx,1);
i:=Sirka_FN(kp,font,ksd);
inc(v^.gd,i);
if pozice.x=v^.spp then          {piseme na konci radku?}
   begin
   inc(i,kx);
   if i>virt^.breiteminus1 then
      dec(poc_zobrX,{i-virt^.breiteminus1}160);
      end else
      if PozText.doz<>0 then         {presahuje tento radek pravy okraj obrazovky?}
         if pozice.x-1>=PozText.doz then dec(poc_zobrX,{PozText.posunv}160);

   if zalamuj then
      begin
      poc_zobrX:=4;
      if kp^=' ' then b:=MoznyPreskokNahoru else b:=false;
      v:=pozice.r^.vazba;
      if v^.gd>virt^.breiteminus1-4 then
         begin
         while v^.crlf=false do Prilep_k_predeslemu(pozice.r^.dalsi,true{false});
         NalamejBuffer(pozice.r);
         end;
      {if B then
         begin
         pozice.x:=1;
         pozice.vx:=1;
         inc(pozice.y);
         pozice.r:=pozice.r^.dalsi;
         end;}
      end;
end;

Procedure editacnipole.ZkusZrusitRozpr;
var p:Pvaznik;
begin
if po_kl_jsme_mimo then
   begin
   swap(poc_zobrX,po_kl_poc_zobrX);
   swap(poc_zobrY,po_kl_poc_zobrY);
   p:=prv_rad;prv_rad:=po_kl_prv_rad;po_kl_prv_rad:=p;
   p:=posl_rad;posl_rad:=po_kl_posl_rad;po_kl_posl_rad:=p;
   end
   else begin
   horz_VycentrovaniKurzoru;
   end;
end;

Procedure editacniPole.OsetriVstup;
var o:word;
    i,ksd:longint;
    kp:pchar;
    ks:string[20];
    r:char;
begin
ks:='';
  if xKeyPressed then
    begin
    o:=ed_key_proc(xreadkey);
    ofn:=FN_default;
    nastavFont(hlavni_font);
    if po_kl_rozpr and (o<>0) then ZkusZrusitRozpr;
    case o of
       xLsipka:KrokZpet;
       xPsipka:KrokVpred;
       xDSipka:SipkaDolu;
       xHsipka:SipkaNahoru;
       xDel:KlavesaDel;
       xEnter:KlavesaEnter;
       xEndk:KlavesaEnd;
       xHome:KlavesaHome;
       xPGDN:KlavesaPGDN;
       xPGUP:KlavesaPGUP;
       xCtrlPgUp:KlavesaCtrlPGUP;
       xCtrlPgDn:KlavesaCtrlPGDN;
       xESC:stav:=_escapem;
       8{BackSpace}:BackSpace;
       byte('<'):begin ks:='<<'#0;ksd:=2;end;
       byte('>'):begin ks:='>>'#0;ksd:=2;end;
       else{case o}
       if mimoradne_osetreni_klavesnice=nil then
          if (o<256) and (o>31) then  {ochrana proti CTRL-neco a ALT-neco}
             begin
             if unicode then
                begin
                ks:=Word2UTF8(PrelozZnak(o,utf8_tbl^))+#0;
                ksd:=Length(ks)-1;
                end
                else begin ks:=char(o)+#0;ksd:=1;end;
             end else
          else begin
          ks:=mimoradne_osetreni_klavesnice(o);
          ksd:=Length(ks)-1
          end;
       end;{case o}
    kp:=@ks;inc(kp);

    if (ks<>'') and povolene_zmeny then
       begin
       kp:=@ks;inc(kp);
       PridejTextNaPoziciKurzoru(kp,ksd);
       end;

    nastavFont(ofn);
    if o<>0 then
       begin
       if po_kl_rozpr then po_kl_rozpr:=false;
       zobraz;
       end;
    end{if KeyPressed}
    else
    if py.probehni then Zobraz;
End;

Procedure EditacniPole.SmazRadku;
var v:PEdRadek;
    a,y1,y2:longint;
    sunout:boolean;
    p:Pvaznik;
begin
v:=pozice.r^.vazba;
y1:=v^.y1;
y2:=v^.y2;
v^.Done;
if PocetRadku=1 then
   begin
   v^.Init;     {jestli existuje jen 1 radka, tak ji proste smazu}
   v^.y1:=y1;
   v^.y2:=y2;
   pozice.r^.vazba:=v;  {zalozim novou}
   pozice.x:=1; {a nastavim kurzor na zacatek radky}
   pozice.vx:=1;
   end
   else begin
   if pozice.r=tot_posl then        {jsme na posledni radce?}
      begin
      pozice.r:=pozice.r^.predchozi;
      tot_posl:=pozice.r;
      dec(pozice.y);
      Dispose(pozice.r^.dalsi,Done);
      sunout:=false;
      end
      else begin
      pozice.r:=pozice.r^.dalsi;
      Dispose(pozice.r^.predchozi,Done);
      sunout:=true;
      end;
   v:=pozice.r^.vazba;
   pozice.x:=Pozice_v_retezci(kx,-1,poc_zobrX,poc_zobrY,v^.p,font);
   pozice.vx:=FN_skut_znak;
   dec(PocetRadku);

   if sunout then
      begin
      if (zalamuj=false) or (pozice.y=1) then
         begin
         a:=y2-y1+1;
         PosunVaznikuPEdRadek(pozice.r,-a);
         end
      else PreskladejRadky;
      end;
   end;
end;

Procedure EditacniPole.SmazZacatekRadky;
var v:PEdRadek;
    p:PVaznik;
    a,y1,y2:longint;
    sunout:boolean;
begin
if pozice.x=1 then Exit;
v:=pozice.r^.vazba;
v^.Vyjmi(1,pozice.x-1);
pozice.x:=1;
if zalamuj=true then PreskladejRadky;
end;

Procedure EditacniPole.SmazKonecRadky;
var v:PEdRadek;
    p:PVaznik;
begin
v:=pozice.r^.vazba;
if pozice.x=v^.spp-1 then Exit;
v^.Vyjmi(pozice.x,v^.spp-pozice.x);
if zalamuj=true then PreskladejRadky;
end;

Procedure EditacniPole.SmazSlovo;
var v:PEdRadek;
    a,b,n:longint;
    p,p2:pchar;
    c:char;
begin
v:=pozice.r^.vazba;
if v^.spp=1 then Exit;
VratSlovo_FN_p(v^.p,pozice.x,a,b);
v^.Vyjmi(a,b-a+1);
if a<>b then
   begin
   pozice.x:=a;
   p:=v^.p;
   inc(p,a-1);
   c:=p^;
   p^:=#0;
   n:=UniLength(v^.p);
   p^:=c;
   pozice.vx:=n+1;
   if zalamuj=true then PreskladejRadky;
   end;
end;

Procedure EditacniPole.vert_VycentrovaniKurzoru;
var v:PEdRadek;
begin
v:=pozice.r^.vazba;
if (v^.y1<poc_zobrY) or (v^.y2>poc_zobrY+virt^.hoehe) then
   poc_ZobrY:=v^.y1-virt^.hoehe div 2;
if poc_ZobrY<0 then poc_ZobrY:=0;
end;

Procedure EditacniPole.horz_VycentrovaniKurzoru;
var v:PEdRadek;
    c:char;
    xx:longint;
begin
v:=pozice.r^.vazba;
xx:=Sirka_FN_na_Xpoz(v^.p,font,pozice.x);
pozice.vx:=FN_skut_znak;
if zalamuj=false then
   begin
   poc_ZobrX:=-(xx-virt^.breite div 2);
   if poc_ZobrX>-100 then poc_ZobrX:=4;
   end;
end;

Procedure EditacniPole.VycentrujNaKurzor;
{jestlize nejaky jiny proces nastavil promenou POZICE a je treba zajistit,
aby tato pozice byla v zobrazovanem useku.}
begin
vert_VycentrovaniKurzoru;
horz_VycentrovaniKurzoru;
end;

Procedure EditacniPole.BlikejKurzorem;
var n:boolean;
begin
{if prinutit and (kkx<>-1) then PutSprite(cil^,kpoz,kkx,kky);}
if povolene_zmeny=false then Exit;
kpoz.hoehe:=kd;
kkx:=kx+x;
kky:=ky-poc_ZobrY+y;
if je_videt then
   begin
   {kpoz.hoehe:=20;}
   n:=PrunikMysi(kkx,kky,kkx,kky+kd-1);
   if N then mousehide;
   GetClippedSprite(cil^,kpoz,kkx,kky);
   LineClipped(cil^,kkx,kky,kkx,kky+kd-1,popredi);
   if N then mouseshow;
   end
   else begin
   n:=Prunik(kkx,kky,kkx,kky+kd-1,
             mouse.x-mouse.hotspot_x,
             mouse.y-mouse.hotspot_y,
             mouse.x-mouse.hotspot_x+mouse.cursor.breite-1,
             mouse.y-mouse.hotspot_y+mouse.cursor.hoehe-1
            );
   if N then mousehide;
   PutClippedSprite(cil^,kpoz,kkx,kky);
   if N then mouseshow;
   end;
end;

Procedure editacniPole.ZhasniKurzor;
begin
if je_videt then
   begin
   je_videt:=false;
   BlikejKurzorem;
   end;
end;

Procedure editacniPole.RozsvitKurzor;
begin
if je_videt=false then
   begin
   je_videt:=true;
   BlikejKurzorem;
   end;
end;

Function EditacniPole.PismenoZpet:longint;
var p,i,j:longint;
begin
p:=poc_ZobrX;
i:=pozice.x;
j:=pozice.vx;
KrokZpet;
PismenoZpet:=pozice.x;
pozice.vx:=j;
pozice.x:=i;
poc_ZobrX:=p;
end;

Procedure EditacniPole.Zobraz;
   Procedure EdPrint_Vaznik_ROZPR;
   {VOLA SE V PRIPADE POSUVNIKO-KLAVESOVEHO ROZPORU - NEOPTIMALIZOVANO}
   var v,kv:PEdradek;
       p:PVaznik;
   begin
   po_kl_jsme_mimo:=true;
   p:=radky^.dalsi;
   while p<>nil do   {napred preskocim radky, ktere jsou nad vyrezem}
      begin v:=p^.vazba;if v^.y2-poc_ZobrY>0 then Break;p:=p^.dalsi;end;
   prv_rad:=p;
   while p<>nil do
      begin
      v:=p^.vazba;
      if v^.y1-poc_zobrY>=virt^.hoehe then Break;
      if p=po_kl_pozice.r then
         po_kl_jsme_mimo:=false;  {radek s kurzorem byl vypsan i v tomto rezimu}
      SetBasicLine(v^.y1-poc_ZobrY);
      Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.spp-1,font);
      posl_rad:=p;
      p:=p^.dalsi;
      end;
   end;

   Procedure EDPrint_Vaznik_NORM;
   {VOLA SE POKUD NIKDO NEHRABAL NA POSUVNIK - JE RYCHLEJSI}
   var v:PEdRadek;
       i:longint;
       b:boolean;
       p:PVaznik;
   begin
   {Zvlastnosti teto procedury je, ze nepise radky po sobe}
   i:=pozice.y;
   v:=pozice.r^.vazba;
   {napred vypisu radek, na kterem je kurzor}
   FN_poloha.B:=URCIZNAK;     {budu chtit znam polohu aktualniho znaku na obrazovce}

   FN_poloha.N:=pozice.x-1;     {(stejne jako jeste dalsi podobne veci)}
   (*FN_poloha.N:=PismenoZpet;  {PROC TOHLE  NEFUNGUJE???}*)

   SetBasicLine(v^.y1-poc_ZobrY);
   Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.spp-1,font);

   prv_rad:=pozice.r;   {napred predpokladam, ze to je prvni viditelna radka}
   posl_rad:=pozice.r;  {a ze je to taky posledni viditelna radka}

   ky:=v^.y1;
   if pozice.x=1 then
      kx:=poc_zobrX else kx:=FN_poloha.x; {polohu zname, takze tam umistime kurzor}
   kd:=v^.y2-v^.y1+1;
   PozText.doz:=FN_poloha._doz;
   PozText.odz:=FN_poloha._odz;
   PozText.posunv:=FN_poloha._posunv;
   PozText.posunm:=FN_poloha._posunm;
   {ted vypisu radky pod kurzorem - ovsem jenom ty, co se vejsou na obrazovku}
   p:=pozice.r^.dalsi;
   while p<>nil do
      begin
      v:=p^.vazba;
      if v^.y1-poc_ZobrY<virt^.hoehe then
         begin
         SetBasicLine(v^.y1-poc_ZobrY);
         Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.spp-1,font);
         posl_rad:=p;
         end
         else begin
         posl_rad:=p^.predchozi;  {zapamatuje si posledni zcela viditelnou radku}
         Break;
         end;
      p:=p^.dalsi;
      end;

   {a nad kurzorem - zase jenom ty, co se vejsou na obrazovku}
   p:=pozice.r^.predchozi;
   while p^.predchozi<>nil do
      begin
      v:=p^.vazba;
      if v^.y2-poc_ZobrY>0 then
         begin
         SetBasicLine(v^.y1-poc_ZobrY);
         Print_FN(poc_zobrX,AUTO_LINE,v^.p,v^.spp-1,font);
         prv_rad:=p;        {zapamatuje si prvni viditelnou radku}
         end
         else begin
         Break;
         end;
      p:=p^.predchozi;
      end;
   end;

{===================== HLAVNI TELO PROCEDURY ZOBRAZ =========================}
var skutecna_sirka:longint;
    i,ll:longint;
    v:PEdRadek;
begin
Ufon;
{ZkontrolujYY;}
FN_color:=popredi;
NastavVystup(virt^);
SetBasicLine(poc_zobrY);
ll:=GetLastLine;
SetLastLine(virt^.hoeheminus1);

if po_kl_rozpr then EdPrint_Vaznik_ROZPR
               else EdPrint_Vaznik_NORM;
SetLastLine(ll);
MouseLock;
MouseSelfCopy(virt^,x,y);
PutSprite_and_clear(cil^,virt^,x,y,pozadi);
MouseUnLock;

if (stav<>_odkliknutim) then
   begin
   je_videt:=true;
   puvodni_citac:=FromTimer;
   BlikejKurzorem;
   end;

{mouseshow;}
py.hodnota:=poc_ZobrY;
v:=tot_posl^.vazba;
py.virtvyska:=v^.y2;
py.Zobraz;
NastavVystup(cil^);

ED_Zobr_proc;

Ofon;
end;


Procedure EditacniPole.ZmenBarvuPozadi(w:word);
begin
pozadi:=w;
Clr(virt^,pozadi);
end;


Procedure EditacniPole.EP_ZavriSoubor;
var v:PEdRadek;
    i:dword;
begin
i:=0;
while radky^.dalsi<>nil do
    begin
    inc(i);
    v:=radky^.dalsi^.vazba;
    if v<>nil then dispose(v,Done); {V by ale melo byt prirazeno vzdy...}
    dispose(radky^.dalsi,done);
    end;
end;

Procedure EditacniPole.NovySoubor;
var v:PEdRadek;
    i:longint;
begin
ufon;
EP_ZavriSoubor;
v:=New(PEdRadek,Init);
v^.y1:=0;
i:=Vyska_FN_default-1;
v^.y2:=i;
v^.yy:=1;
radky^.InitNext(v);
SkocNaZacatek;
tot_posl:=pozice.R;
PocetRadku:=1;
byla_zmena:=false;
ofon;
end;

Procedure EditacniPole.EP_PridejVetsi(v:PEdRadek);
var k,u,n:longint;
    r:real;
    tbm:string;

begin
k:=0;
n:=v^.spp-1;
while k<=n do
   begin
   if v^.p[k]='<' then
      begin
      v^.vloz('<',1,k+1);
      inc(k,2);
      inc(n);
      end else
   if v^.p[k]='>' then
      begin
      v^.vloz('>',1,k+1);
      inc(k,2);
      inc(n);
      end else
   if v^.p[k]=#9 then {rozklad tabulatoru na mezery}
      begin
      v^.vyjmi(k+1,1);
      u:=(k+1) mod tab_na_mezery;
      u:=tab_na_mezery-u+1;
      tbm:=XMezer(u);
      v^.vlozS(tbm,k+1);
      inc(n,u-1);
      end
      else begin
      if v^.p[k]>#127 then
      {Detekce, je-li soubor v unicode ci, jsou-li to 8-bitove narodni znaky}
         begin
         inc(prac1);
         if v^.p[k]<#224 then
            if k<n then if (v^.p[k+1]>#127) and (v^.p[k+1]<#192) then
               begin inc(k);inc(prac2);end
            else else else {>224 tzn. 3bajtove znaky}
            if k-1<n then if (v^.p[k+1]>#127) and (v^.p[k+1]<#192) and (v^.p[k+1]>#127) and (v^.p[k+1]<#192) then
               begin inc(k,2);inc(prac2);end;
         end;
      inc(k);

      end;
   end;
end;

Procedure EditacniPole.EP_UberVetsi(v:PEdRadek);
var k,l:longint;
begin
l:=v^.spp-1;
k:=0;
while k<=l do
   begin
   if (v^.p[k]='<') {and (hodnota[k+1]='<')} then
      begin
      v^.vyjmi(k+1,1);
      dec(l);
      end else
   if (v^.p[k]='>') {and (hodnota[k+1]='<')} then
      begin
      v^.vyjmi(k+1,1);
      dec(l);
      end;
   inc(k);
   end;
end;

Procedure EditacniPole.PridelRadky;
var p:PVaznik;
    v:PEdRadek;
    vfn,pryy,i:longint;
    f:fn;
begin
vfn:=Vyska_FN(FN_selector^[Nacti_FNSLR(hlavni_font)].font);
ofn:=fn_default;
nastavfont(hlavni_font);
i:=0;
pryy:=0;
p:=radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   inc(pryy);
   v^.y1:=i;
   v^.y2:=i+vfn-1;
   v^.yy:=pryy;
   if zalamuj then v^.gd:=virt^.breite else
      v^.gd:=Sirka_FN(v^.p,font,v^.spp-1);
   inc(i,vfn);
   p:=p^.dalsi;
   end;
nastavfont(ofn);
if zalamuj then NalamejBuffer(radky^.dalsi);
end;

Procedure EditacniPole.PreskladejRadky;
var p:PVaznik;
    v:PEdRadek;
begin
p:=pozice.r^.predchozi;
v:=p^.vazba;

if v^.crlf=false then
   begin
   Prilep_k_predeslemu(p^.dalsi,true); {eventualni spojeni s hornim radkem}
   end;

p:=pozice.r;
v:=p^.vazba;

while v^.crlf<>true do Prilep_k_predeslemu(p^.dalsi,true);
v^.gd:=virt^.breite;
if p^.predchozi^.predchozi<>nil then p:=p^.predchozi;
NalamejBuffer(p);
{pozice.r:=p^.dalsi;}
end;

Procedure EditacniPole.NalamejBuffer(pr:PVaznik);
var v,v2,nv:PEdRadek;
    p,novy:PVaznik;
    a,i,l,oi,pryy,yz,vrad:longint;
    d1,d2,d3,d4:longint;
    dbg:string;
    f:fn;
begin
p:=pr;
v:=p^.vazba;
yz:=v^.y1;
pryy:=v^.yy;
f:=String2FN(hlavni_font);
ofn:=fn_default;
nastavfont(hlavni_font);
vrad:=vyska_fn(f)-1;
while p<>nil do
   begin
   v:=p^.vazba;
   if jednotna_vyska_radku then
      begin
      v^.y1:=yz;
      v^.y2:=yz+vrad;
      yz:=v^.y2+1;
      end
      else begin
      vrad:=RychlaVyskaRadky(v^.p);
      v^.y1:=yz;
      v^.y2:=v^.y1+vrad;
      yz:=v^.y2+1;
      end;
   v^.yy:=pryy;
   if v^.gd>virt^.breiteminus1-4 then
      begin
      i:=Pozice_v_retezci(virt^.breiteminus1,v^.y1+1,4,0,v^.p,font);
      if i<v^.spp then
         begin               {dlouha radka - bude treba zalamovat}
         oi:=i;
         v^.smezerou:=true;

         {pujdu zpatky a budu hledat mezeru}
         while v^.p[i-1]<>' ' do
            if i=1 then begin i:=oi;v^.smezerou:=false;Break;end else dec(i);
         {I je ted na posledni mezere od predchoziho slova}
         if v^.smezerou then l:=1 else l:=0;

         nv:=New(PedRadek,Init);
         v^.Rozdel(nv^,i,l);
         v^.gd:=Sirka_FN(v^.p,font,v^.spp-1);
         a:=FN_skut_znak;
         if jednotna_vyska_radku=false then
            begin
            vrad:=RychlaVyskaRadky(v^.p);
            v^.y2:=v^.y1+vrad;
            yz:=v^.y2+1;
            end;

         v^.crlf:=false;     {radek uz neni ukoncen natvrdo pomoci CRLF, ale je ukoncen pruzne}
         nv^.gd:=Sirka_FN(nv^.p,font,nv^.spp-1);
         dec(i,l);
         novy:=New(PVaznik,Init(nil,nil));
         novy^.vazba:=nv;
         p^.insert(novy);
         inc(pocetradku);
         if pozice.y=v^.yy then
            begin
            if pozice.x>i then {nemuze tu byt >=}
               begin
               v2:=posl_rad^.vazba;
               if v^.y2+vrad-Poc_ZobrY>virt^.hoeheminus1 then
                  inc(poc_ZobrY,vyska_fn(f)+1);
               pozice.y:=pozice.y+1;
               pozice.x:=pozice.x-i-1;

               Sirka_FN_na_Xpoz(nv^.p,font,pozice.x);

               pozice.vx:=FN_skut_znak;
               pozice.r:=novy;
               end;
            end;

         if posledni_vyskyt.y=v^.yy then posledni_vyskyt.r:=nil;

         end
         else begin          {radka se na obrazovku preci jen vejde - nebudu zalamovat}
         v^.gd:=FN_poz_v_ret_delka_radky;
         v^.crlf:=true;
         end;
      end;
   inc(pryy);
   tot_posl:=p;
   p:=p^.dalsi;
   end;
if pozice.x=0 then pozice.x:=1; {vojeb, spravne by nemelo nikdy nastat}
nastavfont(ofn);
end;


Procedure EditacniPole.PospojujRadky(merit:boolean);
var p:PVaznik;
    v:PEdRadek;
    i,j:longint;
begin
i:=0;
j:=Vyska_FN(FN_selector^[Nacti_FNSLR(hlavni_font)].font);
p:=radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   while v^.crlf=false do
      Prilep_k_predeslemu(p^.dalsi,true); {druhy radek prilepi k prvnimu}
   v^.y1:=i;
   v^.y2:=i+j-1;
   inc(i,j);
   if merit then v^.gd:=Sirka_FN(v^.p,font,v^.spp-1) else v^.gd:=virt^.breite;
   tot_posl:=p;
   p:=p^.dalsi;
   end;
end;

Procedure EditacniPole.ZmenFont(s:string);
var a,b:longint;
    p:PVaznik;
    v:PEdRadek;
    f:fn;
begin
if zalamuj then
   begin
   PospojujRadky(false);
   hlavni_font:=s;
   NalamejBuffer(radky^.dalsi);
   end else
   begin
   p:=radky^.dalsi;
   hlavni_font:=s;
   a:=Nacti_FNSLR(s);
   f:=FN_selector^[a].font;
   b:=vyska_fn(f);
   a:=0;
   while p<>nil do
      begin
      v:=p^.vazba;
      v^.y1:=a;
      v^.y2:=a+b-1;
      inc(a,b);
      v^.gd:=Sirka_FN(v^.p,font,v^.spp-1);
      p:=p^.dalsi;
      end;
   end;
end;

Procedure SrovnejYYradek(p:Pvaznik);
var v:PEdRadek;
    i:longint;
begin
i:=0;
p:=p^.dalsi;
while p<>nil do
   begin
   inc(i);
   v:=p^.vazba;
   v^.yy:=i;
   p:=p^.dalsi;
   end;
end;

Function EditacniPole.DejLinearniPozici:longint;
var p:PVaznik;
    v:PEdRadek;
    i:longint;
begin
i:=0;
p:=radky^.dalsi;
while p<>pozice.r do
   begin
   v:=p^.vazba;
   i:=i+v^.spp;
   p:=p^.dalsi;
   end;
i:=i+pozice.x;
DejLinearniPozici:=i;
end;

Procedure EditacniPole.NastavLinearniPozici(i:longint);
var p:PVaznik;
    v:PEdRadek;
    j,k:longint;
begin
j:=0;
k:=1;
p:=radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if j+v^.spp>i then break else inc(j,v^.spp);
   inc(k);
   p:=p^.dalsi;
   end;
pozice.r:=p;
pozice.y:=k;
pozice.x:=i-j;
if pozice.x=0 then pozice.x:=1; {vojeb, nemelo by nikdy nastat}
end;

Procedure EditacniPole.PosouvaciRezim;
var i:longint;
begin
i:=DejLinearniPozici;
zalamuj:=false;
PospojujRadky(true);
SrovnejYYradek(radky);
NastavLinearniPozici(i);
{SkocNaZacatek;}
VycentrujNaKurzor;
end;

Procedure EditacniPole.ZalamovaciRezim;
var i:longint;
begin
i:=DejLinearniPozici;
zalamuj:=true;
NalamejBuffer(radky^.dalsi);
NastavLinearniPozici(i);
{SkocNaZacatek;}
VycentrujNaKurzor;
end;

Procedure EditacniPole.SkocNaZacatek;
begin
poc_ZobrX:=4;
poc_ZobrY:=0;
pozice.x:=1;
pozice.vx:=1;
pozice.y:=1;
pozice.r:=radky^.dalsi;
end;

Function EditacniPole.NactiZeStreamu(var s:TStream):byte;
const BUFFER = 65536;
var l,m,k:longint;
    p:pchar;
    r:PVaznik;
    v:PEdRadek;
    postup,pokracovat:boolean;

begin
ufon;
MouseSetCursor(UKmysCekej);
l:=s.GetSize;
if l=0 then
   begin
   ofon;
   NovySoubor;
   MouseSetCursor(UKmys);
   NactiZeStreamu:=edna_OK;
   Exit;
   end;
MyGetMem(p,BUFFER+1);
EP_ZavriSoubor;         {Odstrani prave nactenou vec}
tot_posl:=nil;
pokracovat:=true;
PocetRadku:=0;
postup:=l>=BUFFER*10;

repeat
l:=s.GetPos;               {zaznamenam pozici ve streamu pred ctenim}
s.Read(p^,BUFFER);        {pokusim se precist VELBUF bajtu}
if s.status<>stOK then  {nedoslo ke cteni za koncem souboru?}
   begin
   s.reset;                {resetuj chybovy stav}
   l:=s.GetSize-l;         {a zjisti, jak velky byl tento posledni usek}
   s.Read(p^,l);           {udelam tedy druhy pokus o nacteni}
   end
   else l:=s.GetPos-l;     {o kolik bajtu jsme se soupli?}
if l<>0 then
   begin
   if p[0]=#10 then m:=1 else m:=0;  {kdyz minuly blok skoncil #13 a na zacatku }                                  {tohodle by z CRLF zustalo #10}
   repeat
      k:=IndexByte(p[m],l,13);    {budu hledat #13 - tedy Enter}
      if k=-1 then
         begin
         DalsiRadka(p,m,false);
         m:=l;
         end;

      if k<>-1 then
         begin
         {Ted by nebylo od veci zkontrolovat, jesli se v tomhle useku nevyskytuje
         znak #0 a v tom pripade ho nahradit mezerou}
         p[m+k]:=#0;           {znak #13 nahradim znakem #0}
         DalsiRadka(p,m,true);
         if p[m+k+1]=#10 then inc(m,k+2) else inc(m,k+1);
         end;
   until m>=l;
   if postup and (ukaz_postup_nahravani<>nil) then
      begin
      pokracovat:=Ukaz_Postup_Nahravani(s.GetPos/s.GetSize*100);
      if pokracovat=false then
         begin
         ofon;
         NovySoubor;
         MouseSetCursor(UKmys);
         FreeMem(p,BUFFER+1);
         NactiZeStreamu:=edna_CANCELED;
         Exit;
         end;
      end;
   end;
until l<>BUFFER;
if postup and (ukaz_postup_nahravani<>nil) then
   Ukaz_Postup_Nahravani(-1);
DalsiRadka(nil,0,true);     {ukoncime pripadnou rozdelanou radku}
FreeMem(p,BUFFER+1);
SkocNaZacatek;
MouseSetCursor(UKmys);
NactiZeStreamu:=edna_OK;
if zalamuj then NalamejBuffer(pozice.r);
ofon;
end;

Procedure EditacniPole.DalsiRadka(u:PChar;poz:longint;ukoncena:boolean);
var k,y1,yy:longint;
    v,e:PEdRadek;
    b:boolean;
begin
if tot_posl<>nil then
   begin
   e:=tot_posl^.vazba;
   y1:=e^.y2+1;
   yy:=e^.yy+1;
   b:=e^.smezerou;     {je predchozi radek ukoncen?}
   end
   else begin
   y1:=0;yy:=1;
   tot_posl:=radky;
   b:=true;
   end;
if u<>nil then inc(u,poz);
if B then {delame uplne novy radek}
   begin
   if u=nil then Exit;
   v:=New(PEdRadek,Init);
   v^.Vloz(u,1);
   v^.smezerou:=ukoncena;
   if ukoncena then
      begin
      if konverze_tagu then EP_PridejVetsi(v);
      v^.gd:=Sirka_FN(v^.p,font,v^.spp-1);
      end;
   if jednotna_vyska_radku=true
      then k:=RychlaVyskaRadky('')
      else k:=RychlaVyskaRadky(v^.p);
   v^.y1:=y1;
   v^.y2:=y1+k;
   v^.yy:=yy;
   inc(PocetRadku);
   tot_posl:=tot_posl^.InitNext(v);   {Doplnim posledni radku}
   end
   else begin
   if u<>nil then e^.Vloz(u,e^.spp);
   e^.smezerou:=ukoncena;
   if ukoncena then
      begin
      if konverze_tagu then EP_PridejVetsi(e);
      e^.gd:=Sirka_FN(e^.p,font,e^.spp-1);
      end;
   end;
end;

Function EditacniPole.NactiZVazniku(p:PVaznik):boolean;
var q,r:PVaznik;
    u:PChar;
    v:PString;
    z:string;
    i:longint;
    e:PEdRadek;
begin
EP_ZavriSoubor; {Odstrani prave nactenou vec}
PocetRadku:=0;
tot_posl:=nil;
u:=p^.vazba;
Move(u^,z,4);
z[0]:=#3;
if z='#*#' then        {pro jednoradkove textiky}
   begin
   v:=pointer(u);
   z:=v^;
   delete(z,1,4);
   i:=Pos('#',z);
   delete(z,1,i+1);
   z:=z+#0;
   u:=@z[1];
   DalsiRadka(u,0,true);
   end
   else begin          {pro viceradkove texty}
   p:=p^.dalsi;
   while p<>nil do
      begin
      v:=p^.vazba;
      z:=v^+#0;
      u:=@z[1];
      DalsiRadka(u,0,true);
      p:=p^.dalsi;
      end;
   end;
SkocNaZacatek;
zalamuj:=true;
NalamejBuffer(pozice.r);
Zobraz;
end;

Function EditacniPole.NactiSoubor(s:string):byte;
var t:TBufStream;
begin
if not ExistFile(s) then Exit(edna_NOFILE);
t.Init(s,stOpenRead,32768);
NactiSoubor:=NactiZeStreamu(t);
byla_zmena:=false;
t.Done;
end;

Function EditacniPole.UlozDoStreamu(var s:TStream):boolean;
var p:pointer;
    r:PVaznik;
    v:PEdRadek;
    m,l,k:longint;
    crlf:word;
    mz:char;
begin
crlf:=$0a0d;
mz:=' ';
MouseSetCursor(UKmysCekej);
r:=radky^.dalsi;
while r<>nil do
   begin
   v:=r^.vazba;
   if v^.spp>1 then
      begin
      if konverze_tagu then EP_UberVetsi(v);
      l:=v^.spp-1;      {nepocitam ukoncovaci #0}
      s.Write(v^.p^,l);
      if konverze_tagu then EP_PridejVetsi(v);
      end;
   if v^.crlf then s.Write(crlf,2) else s.Write(mz,1);
   r:=r^.dalsi;
   end;
MouseSetCursor(UKmys);
UlozDoStreamu:=true;
end;

Function EditacniPole.UlozSoubor(s:string):boolean;
var t:TMemoryStream;
    t2:TBufStream;
    b:boolean;
    d1,e2,e3:string;
begin
s:=FExpand(s);
Fsplit(s,d1,e2,e3);     { chceme adresar, jmeno a priponu cile }
if not ExistDir(d1) then
   begin
   b:=MakeDir(d1);  { testneme zacatek cesty }
   if b=false then Exit(false);
   end;
t.Init(40000,20000);
UlozSoubor:=UlozDoStreamu(t);
t.seek(0);
t2.Init(s,stCreate,40000);
if t2.ErrorInfo<>0 then
   begin t.Done;t2.Done;Exit(false);end;

t2.CopyFrom(t,t.GetSize);
if t2.ErrorInfo<>0 then
   begin t.Done;t2.Done;Exit(false);end;
t.Done;
t2.Done;
byla_zmena:=false;
UlozSoubor:=true;
end;

Function Editacnipole.ZkontrolujYY:boolean;
var p:Pvaznik;
    v:PEdRadek;
    a:longint;

    s:string;
    yy,_yy,yy_:longint;
begin
ZkontrolujYY:=true;
a:=0;
p:=radky^.dalsi;
while p<>nil do
   begin
   v:=p^.vazba;
   if v^.yy=a+1 then inc(a)
      else begin
      s:=v^.p;
      yy:=v^.yy;
      v:=p^.predchozi^.vazba;
      _yy:=v^.yy;
      v:=p^.dalsi^.vazba;
      _yy:=v^.yy;
      end;
   p:=p^.dalsi;
   end;
end;

Destructor EditacniPole.Done;
begin
kpoz.hoehe:=100;
Kill_VW(kpoz);
Kill_VW(virt^);
EP_ZavriSoubor;
Dispose(radky,done);
end;

Procedure TextoveOkno(x,y,sirka,vyska:longint;popis:string;p:PVaznik);
var e:PEditacniPole;
    ok:pokno;
    okt:pTlacitko;
    _o:word;
    i:longint;
begin
_o:=ovbarva;
ovbarva:=tvbarva;
OKokno_mustr(ok,x,y,sirka,vyska,popis,'',okt);
ovbarva:=_o;
i:=okt^.y-2;

e:=New(PEditacniPole,Init(ok^.x+2,ok^.y+ok^.vyska_zahlavi+1,ok^.sirka-2,i-(ok^.y+ok^.vyska_zahlavi),true));
e^.konverze_tagu:=false;
e^.povolene_zmeny:=false;
e^.jednotna_vyska_radku:=false;
e^.po_kl_rozpr:=true;
e^.NactiZVazniku(p);

repeat
okt^.kontrola;
e^.Kontrola;
if xLastKey in [xEnter,xESC] then Break;
until okt^.klik=1;

Dispose(e,Done);
Dispose(ok,done);
Dispose(okt,Done);
end;

end.
