{****************************************************************************}
{Modul VENOMBNK.INC - it is a part of the VenomGFX unit and adds some support}
{for routines which use the banking access into videomemory                  }
{      written by Laaca                                                      }
{****************************************************************************}



Procedure NavysBank;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{Input:    bank_wr or bank_rd (longint) - actual bank

 Output:   none
 Destroys: EAX, EDX, high word of EBX}
asm
shl ebx,16
cmp bank_internal.zapis,0
jz @probiha_cteci_rutina
   mov edx,bank_internal.bank_wr
   add edx,bank_internal.grann     {granularita muze byt<>64}
   mov bank_internal.bank_wr,edx
   Call bank_internal.SetBank_wr
   jmp @Konec


@probiha_cteci_rutina:
   mov edx,bank_internal.bank_rd
   add edx,bank_internal.grann     {granularita muze byt<>64}
   mov bank_internal.bank_rd,edx
   Call bank_internal.SetBank_rd
@konec:
shr ebx,16
end;


Procedure BankShowTestScreen;assembler;
var clr,mg:longint;
asm
mov mouse.busy2,1
push es
mov es,vga.segment
xor edx,edx
mov mg,0

@znovu:
mov edi,bank_internal.seg_wr   {start, odkud zapisovat}
mov ecx,edx
call bank_internal.SetBank_wr    {Nastavi bank}
mov edx,ecx
mov ecx,16384
mov eax,clr

mov clr,$2f2f2f2f
test mg,1
jz @hop
mov clr,$aa44aa44
@hop:
inc mg
mov eax,clr
rep stosd

add edx,bank_internal.grann
cmp edx,bank_internal.bisgm
jbe @znovu
pop es
mov mouse.busy2,0
end;


Procedure BankFlip_SVGA_and_clrscr(var source:virtualwindow;c:word);assembler;
var po:array[0..1] of longint;
asm
mov mouse.busy2,1
   push es
   mov es,vga.segment
   mov esi,source
   mov esi,ds:[esi+2]   { ziskani offsetu }
   xor edx,edx
   mov bx,c
   shl ebx,16
   mov bx,c

cmp cpu_info_mmx,0
je @NoMMX_so_Jump

MovD mm0,ebx
MovD mm1,ebx
Psllq mm0,32
Paddusw mm0,mm1
MovQ po,mm0

Cmp cpu_info_emmx,0
je @go_mmx

  @Dalsi_Bank_EMMX:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr   {start, odkud zapisovat}
  mov ecx,1024
  @SCHLEIFE_EMMX:   {Kdyz je podporovano EMMX}
     MovQ mm0,[esi    ];MovQ mm1,[esi+  8];
     MovQ mm2,[esi+ 16];MovQ mm3,[esi+ 24];
     MovQ mm4,[esi+ 32];MovQ mm5,[esi+ 40];
     MovQ mm6,[esi+ 48];MovQ mm7,[esi+ 56];
     MovntQ es:[edi    ],mm0;MovntQ es:[edi+  8],mm1;
     MovntQ es:[edi+ 16],mm2;MovntQ es:[edi+ 24],mm3;
     MovntQ es:[edi+ 32],mm4;MovntQ es:[edi+ 40],mm5;
     MovntQ es:[edi+ 48],mm6;MovntQ es:[edi+ 56],mm7
     movq mm0,po
     MovntQ [esi    ],mm0;MovntQ [esi+  8],mm0;
     MovntQ [esi+ 16],mm0;MovntQ [esi+ 24],mm0;
     MovntQ [esi+ 32],mm0;MovntQ [esi+ 40],mm0;
     MovntQ [esi+ 48],mm0;MovntQ [esi+ 56],mm0
  Add esi,64
  Add edi,64
  Dec ecx
  JNZ @SCHLEIFE_EMMX

  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_Bank_EMMX
  emms
  jmp @spojeni

@go_mmx: {vstupne EDX=0}
   @Dalsi_Bank_MMX:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr   {start, odkud zapisovat}

  mov ecx,1024
  @SCHLEIFE_MMX:   {Kdyz je podporovano MMX, ale ne EMMX}
     MovQ mm0,[esi    ];MovQ mm1,[esi+  8];
     MovQ mm2,[esi+ 16];MovQ mm3,[esi+ 24];
     MovQ mm4,[esi+ 32];MovQ mm5,[esi+ 40];
     MovQ mm6,[esi+ 48];MovQ mm7,[esi+ 56];
     MovQ es:[edi    ],mm0;MovQ es:[edi+  8],mm1;
     MovQ es:[edi+ 16],mm2;MovQ es:[edi+ 24],mm3;
     MovQ es:[edi+ 32],mm4;MovQ es:[edi+ 40],mm5;
     MovQ es:[edi+ 48],mm6;MovQ es:[edi+ 56],mm7
     movq mm0,po
     MovQ [esi    ],mm0;MovQ [esi+  8],mm0;
     MovQ [esi+ 16],mm0;MovQ [esi+ 24],mm0;
     MovQ [esi+ 32],mm0;MovQ [esi+ 40],mm0;
     MovQ [esi+ 48],mm0;MovQ [esi+ 56],mm0
  Add esi,64
  Add edi,64
  Dec ecx
  JNZ @SCHLEIFE_MMX

  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_Bank_MMX
  emms
  jmp @spojeni

@NoMMX_so_Jump:
push ebx
   @Dalsi_Bank:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr   {start, odkud zapisovat}
   mov ecx,16384
pop ebx
@smycka:
   mov eax,ebx
   xchg eax,[esi]
   mov es:[edi],eax
   add edi,4
   add esi,4
   dec ecx
   jnz @smycka

   add edx,bank_internal.grann
   cmp edx,bank_internal.bisgm
   jbe @Dalsi_Bank

@spojeni:
mov eax,bank_internal.numm
mov bank_internal.bank_wr,eax
pop es
mov mouse.busy2,0
end;


Procedure BankFlip_SVGA(var source:virtualwindow);assembler;
asm
mov mouse.busy2,1
push es
mov es,VGA.segment
mov esi,source
mov esi,ds:[esi+2]   { ziskani offsetu }
xor edx,edx

cmp cpu_info_mmx,0
je @NoMMX_so_Jump
Cmp cpu_info_emmx,0
je @go_mmx

  @Dalsi_Bank_EMMX:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr
  mov ecx,1024
  @SCHLEIFE_EMMX:   {Kdyz je podporovano EMMX}
     MovQ mm0,[esi    ];MovQ mm1,[esi+  8];
     MovQ mm2,[esi+ 16];MovQ mm3,[esi+ 24];
     MovQ mm4,[esi+ 32];MovQ mm5,[esi+ 40];
     MovQ mm6,[esi+ 48];MovQ mm7,[esi+ 56];
     MovntQ es:[edi    ],mm0;MovntQ es:[edi+  8],mm1;
     MovntQ es:[edi+ 16],mm2;MovntQ es:[edi+ 24],mm3;
     MovntQ es:[edi+ 32],mm4;MovntQ es:[edi+ 40],mm5;
     MovntQ es:[edi+ 48],mm6;MovntQ es:[edi+ 56],mm7
  Add esi,64
  Add edi,64
  Dec ecx
  JNZ @SCHLEIFE_EMMX

  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_Bank_EMMX
  emms
  jmp @spojeni

@go_mmx:
   @Dalsi_Bank_MMX:
   mov ecx,edx     {EDX je volanim znicen, je treba ho uschovat}
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr
  mov ecx,1024
  @SCHLEIFE_MMX:   {Kdyz je podporovano MMX, ale ne EMMX}
     MovQ mm0,[esi    ];MovQ mm1,[esi+  8];
     MovQ mm2,[esi+ 16];MovQ mm3,[esi+ 24];
     MovQ mm4,[esi+ 32];MovQ mm5,[esi+ 40];
     MovQ mm6,[esi+ 48];MovQ mm7,[esi+ 56];
     MovQ es:[edi    ],mm0;MovQ es:[edi+  8],mm1;
     MovQ es:[edi+ 16],mm2;MovQ es:[edi+ 24],mm3;
     MovQ es:[edi+ 32],mm4;MovQ es:[edi+ 40],mm5;
     MovQ es:[edi+ 48],mm6;MovQ es:[edi+ 56],mm7
  Add esi,64
  Add edi,64
  Dec ecx
  JNZ @SCHLEIFE_MMX

  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_Bank_MMX
  emms
  jmp @spojeni


@NoMMX_so_Jump:
   @Dalsi_Bank:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   call bank_internal.SetBank_wr    {Nastavi bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr

   mov ecx,16384
   rep movsd

   add edx,bank_internal.grann
   cmp edx,bank_internal.bisgm
   jbe @Dalsi_Bank

@spojeni:
mov eax,bank_internal.numm
mov bank_internal.bank_wr,eax
pop es
mov mouse.busy2,0
end;



Procedure StartPosition_into_EDI;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   EBX = start position (upper left corner)
          ECX = line length in bytes (usually set by clipping procedure)
          EDX = number of processed lines (usually set by clipping procedure)
          EDI = VGA variable in VirtualWindow type
          DS musn't be changed!


 OUTPUT:  EDI = final adress of starting position
          Bank_lines = number of processsed lines (copied EDX value)

Does't change other registers}
asm
mov edi,[edi+26]       {ByteBreite}
mov bank_internal.xxx,edi
mov bank_internal.lines,edx     {pocet radku zkopirujeme do bank_lines}
mov bank_internal.bank_ecx,ecx
mov edi,ebx
end;


Procedure StartPosition_into_ESI;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:  EAX - start position in sprite (usually set by clipping proc)
         ESI - sprite of VirtualWindow format

 OUTPUT: ESI - final starting position in sprite
         EAX,Bank_ZZZ - ByteBreite of sprite}
asm
add eax,[esi+2]
mov esi,[esi+26]
xchg esi,eax
mov bank_internal.zzz,eax
end;



Procedure PrepareLine;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   EDI = actual position on screen

 OUTPUT:   ECX = number of bytes to be copied in line before bank switch
           Bank_Zbytek2 = number of lines to be copied in line after bank
                          switch

           Bank_EDI = copy of all 32 bits of EDI
           EDI = clears the high word of EDI

 DESTROYS: EDX
           high word in EBX}
asm
{napred zjistim bank na konci radky}
mov ecx,bank_internal.bank_ecx
add ecx,edi;sub ecx,2   {v ECX ted bude koncova pozice radky}
xor edx,edx
xchg eax,ecx            {v ECX je ulozeno EAX, ktere naopak prepsano z ECX}
div bank_internal.kb64
mov bank_internal.bank2,eax
mov bank_internal.zbytek2,edx
add bank_internal.zbytek2,2

{a ted na zacatku radky}
xor edx,edx
mov eax,edi
div bank_internal.kb64              {bank na zacatku radky bude v EAX}

cmp bank_internal.zapis,0
jz @cteci_operace     {pro rutiny ktere na obrazovku zapisuji}
   cmp eax,bank_internal.bank_wr            {je to jiny bank nez prave pouzivany?}
   jz @nemenbank1
      mov bank_internal.bank_wr,eax         {jestli ano, tak musime prepnout}
      mov edx,eax
      shl ebx,16
      Call bank_internal.Setbank_wr
      shr ebx,16
   @nemenbank1:
   mov edx,bank_internal.bank_wr
   jmp @zapis_i_cteni

@cteci_operace:       {pro rutiny, ktere z obrazovky ctou}
   cmp eax,bank_internal.bank_rd            {je to jiny bank nez prave pouzivany?}
   jz @nemenbank2
      mov bank_internal.bank_rd,eax         {jestli ano, tak musime prepnout}
      mov edx,eax
      shl ebx,16
      Call bank_internal.Setbank_rd
      shr ebx,16
   @nemenbank2:
   mov edx,bank_internal.bank_rd

@zapis_i_cteni:  {ted uz zase spolecne pro zapis i cteni}
mov eax,ecx                {ted uz muzu obnovit EAX}
mov ecx,bank_internal.bank_ecx

cmp edx,bank_internal.bank2         {Je bank na konci radky jiny nez na zacatku?}

jz @NebudePrepnutiBanku
   sub ecx,bank_internal.zbytek2
   jmp @spoj

@NebudePrepnutiBanku:
   mov bank_internal.zbytek2,0
@spoj:

mov bank_internal.bank_edi,edi           {ulozim 32-bitove EDI}
and edi,0000ffffh          {a udelam z nej 16-bitove}

cmp bank_internal.zapis,0
jz @cteci_segment
    add edi,bank_internal.seg_wr
    jmp @konec

@cteci_segment:
    add edi,bank_internal.seg_rd

@konec:
end;


Procedure PrepareLine2;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:    nothing in registers

 OUTPUT:   ZF: 0 = we are not finished, we have to switch bank and continue
               1 = we are finished, let's do next line

           ECX = number of bytes to copy
           EDI = set to new position after second part of line

 DESTROYS: EDX, high word of EBX}
asm
cmp bank_internal.zbytek2,0      {je treba prepnout bank?}
jz @Radka_hotova
    push eax
    Call NavysBank
    pop eax
    mov ecx,bank_internal.zbytek2
    cmp bank_internal.zapis,0
    jz @cteci_rutina
       mov edi,bank_internal.seg_wr
       jmp @spoj

    @cteci_rutina:
       mov edi,bank_internal.seg_rd

    @spoj:
    cmp ecx,0                {zajistime, aby bylo vynulovane ZF}
@Radka_hotova:
end;


Procedure FinishLine;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   nothing in registers
 OUTPUT:  EDI = points on first pixel in next line
          ZF: 0 = we are not finished, let's go on next line
              1 = we are on last line, so we are done}
asm
mov edi,bank_internal.bank_edi
add edi,bank_internal.xxx
dec bank_internal.lines
end;


Procedure Process_HC_copy;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   DS:ESI   position in sprite bitmap
          ES:EDI   position in screen (EDI has cleared higher word)
          ECX      how many bytes to copy

 OUTPUT:  DS:ESI and ES:EDI moved into new position
          ECX = 0

 DESTROYS:AX
}
asm
@cykl:
mov ax,ds:[esi]
cmp ax,bank_internal.hc
jz @preskoc
mov es:[edi],ax
@preskoc:
add edi,2
add esi,2
sub ecx,2
jnz @cykl
end;


Procedure Process_FN_copy;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   DS:ESI   position in sprite bitmap
          ES:EDI   position in screen (EDI has cleared higher word)
          AX       color which to paint
          ECX      how many bytes to copy

 OUTPUT:  DS:ESI and ES:EDI moved into new position
          ECX = 0
}
asm
@cykl:
cmp word ptr [esi],0
jz @preskoc
mov es:[edi],ax
@preskoc:
add edi,2
add esi,2
sub ecx,2
jnz @cykl
end;



Procedure Open_read_mode;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
asm
mov bank_internal.zapis,0   {znak pro volane procedury, ze probiha nikoliv zapisova,}
                   {ale cteci operace}

mov al,bank_internal.win_rd        {pokud karta pouziva jen jedno prostupove okno spolecne}
cmp al,bank_internal.win_wr        {pro cteni a zapis, tak musime synchronizovat zmeny}
jnz @nic
mov eax,bank_internal.bank_wr
mov bank_internal.bank_rd,eax
@nic:
end;


Procedure Close_read_mode;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
asm
mov bank_internal.zapis,1   {prepinac zapisu a cteni vratime do puvodniho stavu}
mov al,bank_internal.win_rd        {pokud karta pouziva jen jedno prostupove okno spolecne}
cmp al,bank_internal.win_wr        {pro cteni a zapis, tak musime synchronizovat zmeny}
jnz @nic
mov eax,bank_internal.bank_rd
mov bank_internal.bank_wr,eax
@nic:
end;


Procedure RLE_Copy;assembler;{$IFDEF EnableInline}inline;{$ENDIF}
{INPUT:   DS:ESI   position in sprite bitmap
          DS:EBX   position in RLE map
          ES:EDI   position in screen (EDI has cleared higher word)

          ECX      starting value of ECX
                   (if ECX=0 read new ECX value)
          EDX      how many pixels can be copied if ENDLINE is not reached

 OUTPUT:  DS:ESI and DS:EBX and ES:EDI moved into new position
          EAX      number of not drawn pixels due a bank switch
          ZF       ZF=1 ENDLINE was reached
                   ZF=0 stopped because all EDX pixels was processed

 DESTROYS: ECX,EDX
}

asm
cmp ecx,0                {mam prednactenou hodnotu ECX?}
jnz @RLE_clip_now_ok    {jestli ano, tak nenacitej novou a hned analyzuj}

@Pokracuj_v_RLE_radce:
movsx ecx,byte ds:[ebx]
    inc ebx

@RLE_CLIP_NOW_OK:
    cmp ecx,0
    jz @TOTAL_END        {ECX=0? Skoc na konec radku}
    jg @RLE_CLIP_MOVE           {ECX>0? Skoc na presun}

    @RLE_CLIP_SKIP:             {ECX<0, tzn. preskocime -ECX pixelu}
    neg ecx
    sub edx,ecx
    sbb eax,eax
    and eax,edx
    add ecx,eax

    add esi,ecx
    add edi,ecx
    add esi,ecx
    add edi,ecx


    neg eax
    cmp edx,0
    jle @Temporary_END
    jmp @Pokracuj_v_RLE_radce

    @RLE_CLIP_MOVE:
    sub edx,ecx
    sbb eax,eax
    and eax,edx
    add ecx,eax

    shr ecx,1;rep movsd;adc ecx,ecx;rep movsw  {fast 32bit write}

    cmp edx,0
    jle @Temporary_END
    jmp @Pokracuj_v_RLE_radce

@Temporary_END:
neg eax     {v EAX bude pocet nezpracovanych pixelu z duvodu zalomeni banku}
cmp ebx,0   {EBX nemuze byt 0, takze zarucene dosahnu vynulovani ZF}
@Total_END: {pokud smeroval skok primo sem, tak plati ze ZF=1}
end;



Procedure BankClippedBar(x1,y1,x2,y2:longint;c:word);assembler;
asm
mov mouse.busy2,1
mov eax,x1
mov ebx,y1
mov ecx,x2
mov edx,y2
lea edi,vga
Call BarClipping
jc @Konec

push es
mov ax,[edi+0]
mov es,ax

mov ax,c
shl eax,16
mov ax,c

Call StartPosition_into_EDI

@SCANLINES_LOOP:

Call PrepareLine

sar ecx,2;rep stosd;adc ecx,ecx;rep stosw  {Zacnu radek}

Call PrepareLine2                          {mozna prepnu bank}
jz @preskoc

sar ecx,2;rep stosd;adc ecx,ecx;rep stosw  {a dodelam ho}

@preskoc:

Call FinishLine
JNZ @SCANLINES_LOOP

pop es
@Konec:
mov mouse.busy2,0
end;



Procedure BankPutClippedPixel(x,y:longint;c:word);assembler;
asm
mov mouse.busy2,1
  lea edi,vga
  Mov eax,ds:[edi+10]
  Cmp x,eax
  Jae @Ende
  Mov eax,ds:[edi+30]
  Cmp y,eax
  Jae @Ende

Push es
  mov es,[edi+0]
  mov eax,[edi+26]
  mul y
  add eax,x
  add eax,x
  mov edi,eax
  div bank_internal.kb64

  cmp eax,bank_internal.bank_wr
  je @nemenbank

  mov edx,eax
  mov bank_internal.bank_wr,eax
  imul edx,bank_internal.grann
  Call bank_internal.Setbank_wr            {zmeni bank}

@nemenbank:
  and edi,0000ffffh
  add edi,bank_internal.seg_wr
  mov ax,c
  mov es:[edi],ax
pop es
@Ende:
mov mouse.busy2,0
end;


Function BankGetClippedPixel(x,y:longint):word;assembler;
asm
mov mouse.busy2,1
xor eax,eax
  lea edi,vga
  Mov ebx,[edi+10]
  Cmp x,ebx
  Jae @Ende
  Mov ebx,[edi+30]
  Cmp y,ebx
  Jae @Ende

Call Open_read_mode

Push es
mov es,[edi+0]

  mov eax,[edi+26]
  mul y
  add eax,x
  add eax,x
  mov edi,eax
  div bank_internal.kb64

  cmp eax,bank_internal.bank_rd
  je @nemenbank

  mov edx,eax
  mov bank_internal.bank_rd,eax
  imul edx,bank_internal.grann
  Call bank_internal.Setbank_rd            {zmeni bank}

@nemenbank:
  and edi,0000ffffh
  add edi,bank_internal.seg_rd
  mov ax,es:[edi]

pop es
Call Close_read_mode
@Ende:
mov mouse.busy2,0
end;


Procedure BankClippedLineVert(x,y1,y2:LongInt;color:word);assembler;
asm
mov mouse.busy2,1
  lea edi,vga
  mov ebx,ds:[edi+30]   {vga.hoehe}
  mov edx,ds:[edi+10]   {vga.breite}

  cmp x,edx
  jae @Ende             {je x<0 nebo x>maxX?}
  shl edx,1             {EDX:=vga.breite*2 (tzn. ByteBreite)}
  mov bank_internal.xxx,edx

  mov eax,y1
  mov ecx,y2
  cmp eax,ecx
  jng @dale                 {y2<y1?}
  xchg eax,ecx              {EAX=mensi souradnice, ECX=vetsi}
  @dale:

  cmp ecx,0
  jl @Ende                  {y2<0}

  cmp eax,ebx           {y1 vs. VGA.hoehe}
  jge @Ende             {y1>=vga.hoehe?  ==> Ende}
   cmp ecx,ebx          {y2 vs. VGA.hoehe}
   jl @jump2            {y2<VGA.hoehe? ==> Jump2}
   lea ecx,[ebx-1]      {y2:=vga.hoehe-1}
@jump2:
   cmp eax,0            {y1 vs. 0}
   jge @jump3
   mov eax,0
@jump3:

   sub ecx,eax
   inc ecx              {EAX=y1,  ECX=y2-y1+1}

   mul bank_internal.xxx         {Y1 := Y1*dest.ByteBreite}
   add eax,x
   add eax,x

   mov dx,[edi+0]
   push es
   mov es,dx

   mov esi,eax
   xor edi,edi

@HL:
   xor edx,edx
   div bank_internal.kb64        {bank bude v EAX}
   cmp eax,bank_internal.bank_wr            {je to jiny bank nez prave pouzivany?}
   jz @nemenbank1
      mov bank_internal.bank_wr,eax         {jestli ano, tak musime prepnout}
      mov edx,eax

      Call bank_internal.Setbank_wr         {znici AX a BX}

   @nemenbank1:
   mov di,si
   mov ax,color
   add edi,bank_internal.seg_wr
   mov es:[edi], ax
   sub edi,bank_internal.seg_wr
   add esi,bank_internal.xxx
   mov eax,esi
   LOOP @HL
  pop es
@ende:
mov mouse.busy2,0
end;


PROCEDURE BankClippedLineHorz(x1,x2,y:LongInt;Color:Word);assembler;
asm
mov mouse.busy2,1
  lea esi,vga
  mov edx,ds:[esi+30]  {vga.hoehe}
  mov ebx,ds:[esi+10]  {vga.breite}
  cmp y,edx
  jae @Ende            {y<0 nebo y>maxY?  ==> Ende}
  mov eax,x1
  mov ecx,x2
  cmp eax,ecx          {x1 vs. x2}
  jng @dale            {x1<x2?  ==> Dalse}
  xchg eax,ecx              {EAX=mensi souradnice, ECX=vetsi}
  @dale:
   cmp ecx,0           {x2 vs. 0}
   jl @Ende            {x2<0? ==> Ende}
   cmp eax,ebx         {x1 vs. vga.breite}
   jge @Ende           {x1>=vga.breite  ==> Ende}
   cmp ecx,ebx         {x2 vs. vga.breite}
   jl @jump2           {x2<=vga.breite?  ==> Jump2}
   lea ecx,[ebx-1]     {x2:=vga.breite-1}
@jump2:
   cmp eax,0           {x1 vs. 0}
   jge @jump3          {x1>0?  ==> jump3}
   mov eax,0           {x1:=0}
@jump3:

push es
   Mov edi,ds:[esi+26] {EDI:=vga.Bytebreite}
   mov bank_internal.xxx,edi
   Mov es ,ds:[esi   ]

   sub ecx,eax
   inc ecx
   shl ecx,1           {ECX na bajty, aby tomu rozumela proc. PrepareLine}
   mov bank_internal.bank_ecx,ecx    {ECX do bank_internal.ECX, aby tomu rozumela proc. PrepareLine}
   IMul edi,y          {EDI:=vga.bytebreite*y}
   shl eax,1
   add edi,eax         {EDI:=vga.bytebreite*y+(x*2)}

   Call PrepareLine

   mov ax,Color
   shl eax,16
   mov ax,color
   sar ecx,2;rep stosd;adc ecx,ecx;rep stosw  {fast 32bit write}

   Call PrepareLine2
   jz @preskoc

   mov ax,Color
   shl eax,16
   mov ax,color
   sar ecx,2;rep stosd;adc ecx,ecx;rep stosw  {fast 32bit write}

   @preskoc:
 Pop es
 @ENDE:
mov mouse.busy2,0
end;


PROCEDURE BankClr(Color:Word); Assembler;
Asm
mov mouse.busy2,1
 Mov ax,Color
 Shl eax,16
 Mov ax,Color

 Push es

  lea edi,vga

  Mov ecx,ds:[edi+6]   {VGA.SIZE}
  Mov es ,ds:[edi+0]
  Mov edi,bank_internal.seg_wr
  xor edx,edx

  cmp cpu_info_mmx,0
  Je @NoMMX_so_Jump

   MovD mm1,eax        {Kdyz je k dispozici MMX}
   MovD mm2,eax
   Psllq mm1,32
   Paddusw mm1,mm2

   Shr ecx,6

  cmp cpu_info_emmx,0
  je @go_mmx

@Dalsi_bank_EMMX:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }

   Call bank_internal.Setbank_wr            {zmeni bank}

   mov edx,ecx
   mov edi,bank_internal.seg_wr

   mov ecx,1024

  @SCHLEIFE_EMMX:
    prefetch es:[edi+32]     {chtelo by nastudovat, jak presne prefetch pracuje}
    MovntQ es:[edi    ],mm1
    MovntQ es:[edi+  8],mm1
    MovntQ es:[edi+ 16],mm1
    MovntQ es:[edi+ 24],mm1
    MovntQ es:[edi+ 32],mm1
    MovntQ es:[edi+ 40],mm1
    MovntQ es:[edi+ 48],mm1
    MovntQ es:[edi+ 56],mm1
    Add edi,64
   Dec ecx
   JNZ @SCHLEIFE_EMMX
  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_bank_EMMX
  Emms
  Jmp @Ende

@go_mmx:
@Dalsi_bank_MMX:
   mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
   Call bank_internal.Setbank_wr         {zmeni bank}
   mov edx,ecx
   mov edi,bank_internal.seg_wr
   mov ecx,1024

   @SCHLEIFE_MMX:
    MovQ es:[edi    ],mm1
    MovQ es:[edi+  8],mm1
    MovQ es:[edi+ 16],mm1
    MovQ es:[edi+ 24],mm1
    MovQ es:[edi+ 32],mm1
    MovQ es:[edi+ 40],mm1
    MovQ es:[edi+ 48],mm1
    MovQ es:[edi+ 56],mm1
    Add edi,64
   Dec ecx
   JNZ @SCHLEIFE_MMX
  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_bank_MMX
  Emms
  Jmp @Ende

@NoMMX_so_Jump:
@Dalsi_bank:
  push eax
  mov ecx,edx     { EDX je volanim znicen, je treba ho uschovat }
  Call bank_internal.Setbank_wr         {zmeni bank}
  mov edx,ecx
  mov edi,bank_internal.seg_wr
  mov ecx,1024
  pop eax

  mov ecx,16384
  Rep StosD

  add edx,bank_internal.grann
  cmp edx,bank_internal.bisgm
  jbe @Dalsi_Bank
 @Ende:
 Pop es
mov eax,bank_internal.numm
mov bank_internal.bank_wr,eax
mov mouse.busy2,0
End;


PROCEDURE BankPutClippedHCSprite(var Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);assembler;
var sprtstrt,skiplin,startecx:longint;
asm
mov mouse.busy2,1
lea edi,vga
mov esi,sprite
mov eax,x
mov ebx,y
call SpriteClipping
jc @Konec

push es
pushf      {uklidim priznak ZF ze SpriteClipping}
mov es,[edi+0]
test byte [esi+20],2    {je pripravena RLE mapa?}
jnz @RLE_mapa

popf
Call StartPosition_into_EDI
Call StartPosition_into_ESI

mov ax,Hidecolor
mov bank_internal.hc,ax

@SCANLINES_LOOP:

Call PrepareLine
push esi
Call Process_HC_copy
Call PrepareLine2
jz @preskoc
   Call Process_HC_copy
@preskoc:

pop esi
add esi,bank_internal.zzz
Call FinishLine

JNZ @SCANLINES_LOOP
jmp @Obnov_ES

{============================ Prubeh s RLE mapou ============================}
@RLE_mapa:
push dword [esi+34] {ulozime si odkaz na RLE mapu}
mov sprtstrt,eax    {uschovam si hodnotu posunu od zacatku spritu do EAX}
Call StartPosition_into_EDI
Call StartPosition_into_ESI
pop ebx             {obnovim odkaz na RLE mapu}
mov skiplin,0
popf
jz @RLE_SCANLINES_LOOP
{----------------------------------------------------------------------------}
@RLE_clipping:          {Pokud byl detekovan clipping, tak prepocty}
cmp sprtstrt,0          {sice byl clipping, ale bez posunu startovaci pozice?}
jz @RLE_SCANLINES_LOOP  {v tom pripade je to jako kdyby clipping nebyl}

mov eax,sprtstrt
xor edx,edx          {Delenec je v EDX:EAX, proto musim nulovat EDX}
div bank_internal.zzz         {podil v EAX, zbytek v EDX}
shl eax,2            {EAX:=EAX*4}
add ebx,eax          {EBX nazmeruju na prvni zpracovavanou radku}
mov skiplin,edx      {v SKIPLIN mame pocet vynechanych bajtu v zac.radku}
shr skiplin,1        {prevedeme na pocet pixelu}
mov edx,ecx          {sirka viditelneho useku (v bajtech) do EDX}
shr edx,1            {prepocitam do poctu pixelu}

{----------------------------------------------------------------------------}
@RLE_SCANLINES_LOOP:
push esi
push ebx               {ulozim seznam na radky}
mov ebx,ds:[ebx]       {odkaz na n-ty radek RLE mapy}
mov startecx,0

cmp skiplin,0
jz @No_skiplin

mov eax,skiplin
{----------------------------------------------------------------------------}
@RLE_CLIP_FIRSTSKIP:
    movsx ecx,byte ds:[ebx]
    inc ebx
    cmp ecx,0
    jz @RLE_TOTALEND_LINE  {ECX=0? Skoc na konec radku}
    jg @RLE_CLIP_SK_POZ

@RLE_CLIP_SK_NEG:  {Kdyz je ECX<0}
    add eax,ecx
    cmp eax,0
    jz @No_skiplin
    jl @RLE_PODTECENI1
    jmp @RLE_CLIP_FIRSTSKIP

@RLE_PODTECENI1:
    mov startecx,eax
    jmp @No_skiplin

@RLE_CLIP_SK_POZ:  {Kdyz je ECX>0}
    sub eax,ecx
    cmp eax,0
    jz @No_skiplin
    jl @RLE_PODTECENI2
    jmp @RLE_CLIP_FIRSTSKIP

@RLE_PODTECENI2:
    neg eax
    mov startecx,eax
    jmp @No_skiplin

{----------------------------------------------------------------------------}
@No_skiplin: {neni potreba odpocitavat prostor za levym okrajem}
    push ebx               {uschovam, protoze bude zniceno v PrepareLine}
    Call PrepareLine     {nastavim banky}
    mov edx,ecx          {do EDX dam pocet bajtu ke zprac. pred zmenou banku}
    shr edx,1            {zmenim to na pocet pixelu}
    pop ebx                {obnova ebx}

{-----------------------------------------------------}
    mov ecx,startecx      {prvotni nastaveni ECX (0=nacti novy bajt)}
    Call RLE_copy
    jz @RLE_TOTALEND_LINE {Pokud bylo dosazeno znacky ENDLINE tak dal nepokr.}

    push ebx
    Call PrepareLine2
    pop ebx
    jz @RLE_TOTALEND_LINE
    mov edx,ecx          {do EDX dam pocet bajtu ke zprac. po zmene banku}
    shr edx,1            {zmenim to na pocet pixelu}
    mov ecx,eax          {do ECX vlozim minule nezpracovane pixely kvuli}
    Call RLE_copy            {zalomeni banku}

   @RLE_TOTALEND_LINE:

    pop ebx
    add ebx,4
    pop esi
    add esi,bank_internal.zzz

  Call FinishLine
  JNZ @RLE_SCANLINES_LOOP
{----------------------------------------------------------------------------}
{----------------------------------------------------------------------------}
@Obnov_ES:
pop es
@Konec:
mov mouse.busy2,0
End;


PROCEDURE _BankPutClippedHCSprite(var Dest,Sprite:VirtualWindow;x,y:LongInt;HideColor:Word);
begin
BankPutClippedHCSprite(Sprite,x,y,HideColor);
end;


PROCEDURE BankPutClippedSprite(var Sprite:VirtualWindow;x,y:LongInt);assembler;
asm
mov mouse.busy2,1
lea edi,vga
mov esi,sprite
mov eax,x
mov ebx,y
call SpriteClipping
jc @Konec

push es
mov es,[edi+0]

Call StartPosition_into_EDI
Call StartPosition_into_ESI

@SCANLINES_LOOP:

Call PrepareLine
push esi
sar ecx,2;rep movsd;adc ecx,ecx;rep movsw  {fast 32bit write}


Call PrepareLine2
jz @preskoc
sar ecx,2;rep movsd;adc ecx,ecx;rep movsw  {fast 32bit write}
@preskoc:

pop esi
add esi,bank_internal.zzz
Call FinishLine

JNZ @SCANLINES_LOOP

pop es
@Konec:
mov mouse.busy2,0
End;

PROCEDURE _BankPutClippedSprite(var Dest,Sprite:VirtualWindow;x,y:LongInt);
begin
BankPutClippedSprite(Sprite,x,y);
end;

Procedure Process_read_copy;assembler;
{copies from ES:EDI into DS:ESI}
asm
@znovu:
cmp ecx,4
jl @zbytek

mov eax,ES:[edi]
mov DS:[esi],eax
add edi,4
add esi,4
sub ecx,4
jnz @znovu
jmp @konec

@zbytek:
mov ax,ES:[edi]
mov DS:[esi],ax
add edi,2
add esi,2
sub ecx,2

@konec:
end;


PROCEDURE BankGetClippedSprite(var sprite:virtualwindow;x,y:LongInt);assembler;
asm
mov mouse.busy2,1
lea edi,vga
mov esi,sprite
mov eax,x
mov ebx,y
call SpriteClipping
jc @Konec

push es
mov es,[edi+0]

Call StartPosition_into_EDI
Call StartPosition_into_ESI

Call Open_read_mode

@SCANLINES_LOOP:

Call PrepareLine
push esi
Call Process_read_copy
Call PrepareLine2
jz @preskoc
   Call Process_read_copy
@preskoc:

pop esi
add esi,bank_internal.zzz
Call FinishLine

JNZ @SCANLINES_LOOP


Call Close_read_mode
pop es
@Konec:
mov mouse.busy2,0
End;

PROCEDURE _BankGetClippedSprite(var Source,Sprite:VirtualWindow;x,y:LongInt);
begin
BankGetClippedSprite(Sprite,x,y);
end;


{*********************************************************************}

Function BankPutChar_FN(p:pointer;x,y,xd,yd:longint;charbytes:byte;c:word):byte;assembler;
{ For unit FNfont2 }
asm
mov mouse.busy2,1
lea esi,fontvw        {nacetl jsem si renderovaci policko pro znaky}

mov eax,xd
mov ebx,yd
mov ecx,eax
shl ecx,1

mov [esi+10],eax  {breite}
mov [esi+30],ebx  {hoehe}
mov [esi+26],ecx  {bytebreite}

lea edi,vga
mov eax,x
mov ebx,y
call FontClipping
jc @Konec

{--cmp neco;jz @rozpakovano}

push edi          {schovam EDI, protoze ji prepisu}
push esi
push ecx
push edx
mov edi,[esi+2]   {bitmapu rozepisu do 16-bitove pixmapy}
mov esi,p         {vezmu bitmapu}
movzx ecx,charbytes

call BitmapaNaPixmapu

pop edx
pop ecx
pop esi
pop edi


@rozpakovano:


push es
mov es,[edi+0]

Call StartPosition_into_EDI
Call StartPosition_into_ESI

mov ax,c

@SCANLINES_LOOP:

Call PrepareLine
push esi
Call Process_FN_copy
Call PrepareLine2
jz @preskoc
   Call Process_FN_copy
@preskoc:

pop esi
add esi,bank_internal.zzz
Call FinishLine

JNZ @SCANLINES_LOOP

pop es
@Konec:
mov al,Font_horiz_clip
mov mouse.busy2,0
end;


